/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "mon_parse.y" /* yacc.c:339  */

/* -*- C -*-
 *
 * mon_parse.y - Parser for the VICE built-in monitor.
 *
 * Written by
 *  Daniel Sladic <sladic@eecg.toronto.edu>
 *  Andreas Boose <viceteam@t-online.de>
 *  Thomas Giesel <skoe@directbox.com>
 *
 * This file is part of VICE, the Versatile Commodore Emulator.
 * See README for copyright notice.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307  USA.
 *
 */

#include "vice.h"

#ifndef __OS2__
#ifdef __GNUC__
#undef alloca
#ifndef ANDROID_COMPILE
#define        alloca(n)       __builtin_alloca (n)
#endif
#else
#ifdef HAVE_ALLOCA_H
#include <alloca.h>
#else  /* Not HAVE_ALLOCA_H.  */
#if !defined(_AIX) && !defined(WINCE)
#ifndef _MSC_VER
extern char *alloca();
#else
#define alloca(n)   _alloca(n)
#endif  /* MSVC */
#endif /* Not AIX and not WINCE.  */
#endif /* HAVE_ALLOCA_H.  */
#endif /* GCC.  */
#endif /* __OS2__ */

/* SunOS 4.x specific stuff */
#if defined(sun) || defined(__sun)
#  if !defined(__SVR4) && !defined(__svr4__)
#    ifdef __sparc__
#      define YYFREE
#    endif
#  endif
#endif

#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "asm.h"
#include "console.h"
#include "drive.h"
#include "interrupt.h"
#include "lib.h"
#include "machine.h"
#include "mon_breakpoint.h"
#include "mon_command.h"
#include "mon_disassemble.h"
#include "mon_drive.h"
#include "mon_file.h"
#include "mon_memmap.h"
#include "mon_memory.h"
#include "mon_register.h"
#include "mon_util.h"
#include "montypes.h"
#include "tapeport.h"
#include "resources.h"
#include "types.h"
#include "uimon.h"
#include "vsync.h"

#ifdef AMIGA_MORPHOS
#undef REG_PC
#endif

#define join_ints(x,y) (LO16_TO_HI16(x)|y)
#define separate_int1(x) (HI16_TO_LO16(x))
#define separate_int2(x) (LO16(x))

static int yyerror(char *s);
static int temp;
static int resolve_datatype(unsigned guess_type, const char *num);
static int resolve_range(enum t_memspace memspace, MON_ADDR range[2],
                         const char *num);

#ifdef __IBMC__
static void __yy_memcpy (char *to, char *from, int count);
#endif

/* Defined in the lexer */
extern int new_cmd, opt_asm;
extern void free_buffer(void);
extern void make_buffer(char *str);
extern int yylex(void);
extern int cur_len, last_len;

#define ERR_ILLEGAL_INPUT 1     /* Generic error as returned by yacc.  */
#define ERR_RANGE_BAD_START 2
#define ERR_RANGE_BAD_END 3
#define ERR_BAD_CMD 4
#define ERR_EXPECT_CHECKNUM 5
#define ERR_EXPECT_END_CMD 6
#define ERR_MISSING_CLOSE_PAREN 7
#define ERR_INCOMPLETE_COND_OP 8
#define ERR_EXPECT_FILENAME 9
#define ERR_ADDR_TOO_BIG 10
#define ERR_IMM_TOO_BIG 11
#define ERR_EXPECT_STRING 12
#define ERR_UNDEFINED_LABEL 13
#define ERR_EXPECT_DEVICE_NUM 14
#define ERR_EXPECT_ADDRESS 15
#define ERR_INVALID_REGISTER 16

#define BAD_ADDR (new_addr(e_invalid_space, 0))
#define CHECK_ADDR(x) ((x) == addr_mask(x))

#define YYDEBUG 1


#line 204 "mon_parse.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_MON_PARSE_H_INCLUDED
# define YY_YY_MON_PARSE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    H_NUMBER = 258,
    D_NUMBER = 259,
    O_NUMBER = 260,
    B_NUMBER = 261,
    CONVERT_OP = 262,
    B_DATA = 263,
    H_RANGE_GUESS = 264,
    D_NUMBER_GUESS = 265,
    O_NUMBER_GUESS = 266,
    B_NUMBER_GUESS = 267,
    BAD_CMD = 268,
    MEM_OP = 269,
    IF = 270,
    MEM_COMP = 271,
    MEM_DISK8 = 272,
    MEM_DISK9 = 273,
    MEM_DISK10 = 274,
    MEM_DISK11 = 275,
    EQUALS = 276,
    TRAIL = 277,
    CMD_SEP = 278,
    LABEL_ASGN_COMMENT = 279,
    CMD_LOG = 280,
    CMD_LOGNAME = 281,
    CMD_SIDEFX = 282,
    CMD_DUMMY = 283,
    CMD_RETURN = 284,
    CMD_BLOCK_READ = 285,
    CMD_BLOCK_WRITE = 286,
    CMD_UP = 287,
    CMD_DOWN = 288,
    CMD_LOAD = 289,
    CMD_SAVE = 290,
    CMD_VERIFY = 291,
    CMD_BVERIFY = 292,
    CMD_IGNORE = 293,
    CMD_HUNT = 294,
    CMD_FILL = 295,
    CMD_MOVE = 296,
    CMD_GOTO = 297,
    CMD_REGISTERS = 298,
    CMD_READSPACE = 299,
    CMD_WRITESPACE = 300,
    CMD_RADIX = 301,
    CMD_MEM_DISPLAY = 302,
    CMD_BREAK = 303,
    CMD_TRACE = 304,
    CMD_IO = 305,
    CMD_BRMON = 306,
    CMD_COMPARE = 307,
    CMD_DUMP = 308,
    CMD_UNDUMP = 309,
    CMD_EXIT = 310,
    CMD_DELETE = 311,
    CMD_CONDITION = 312,
    CMD_COMMAND = 313,
    CMD_ASSEMBLE = 314,
    CMD_DISASSEMBLE = 315,
    CMD_NEXT = 316,
    CMD_STEP = 317,
    CMD_PRINT = 318,
    CMD_DEVICE = 319,
    CMD_HELP = 320,
    CMD_WATCH = 321,
    CMD_DISK = 322,
    CMD_QUIT = 323,
    CMD_CHDIR = 324,
    CMD_BANK = 325,
    CMD_LOAD_LABELS = 326,
    CMD_SAVE_LABELS = 327,
    CMD_ADD_LABEL = 328,
    CMD_DEL_LABEL = 329,
    CMD_SHOW_LABELS = 330,
    CMD_CLEAR_LABELS = 331,
    CMD_RECORD = 332,
    CMD_MON_STOP = 333,
    CMD_PLAYBACK = 334,
    CMD_CHAR_DISPLAY = 335,
    CMD_SPRITE_DISPLAY = 336,
    CMD_TEXT_DISPLAY = 337,
    CMD_SCREENCODE_DISPLAY = 338,
    CMD_ENTER_DATA = 339,
    CMD_ENTER_BIN_DATA = 340,
    CMD_KEYBUF = 341,
    CMD_BLOAD = 342,
    CMD_BSAVE = 343,
    CMD_SCREEN = 344,
    CMD_UNTIL = 345,
    CMD_CPU = 346,
    CMD_YYDEBUG = 347,
    CMD_BACKTRACE = 348,
    CMD_SCREENSHOT = 349,
    CMD_PWD = 350,
    CMD_DIR = 351,
    CMD_MKDIR = 352,
    CMD_RMDIR = 353,
    CMD_RESOURCE_GET = 354,
    CMD_RESOURCE_SET = 355,
    CMD_LOAD_RESOURCES = 356,
    CMD_SAVE_RESOURCES = 357,
    CMD_ATTACH = 358,
    CMD_DETACH = 359,
    CMD_MON_RESET = 360,
    CMD_TAPECTRL = 361,
    CMD_CARTFREEZE = 362,
    CMD_UPDB = 363,
    CMD_JPDB = 364,
    CMD_CPUHISTORY = 365,
    CMD_MEMMAPZAP = 366,
    CMD_MEMMAPSHOW = 367,
    CMD_MEMMAPSAVE = 368,
    CMD_COMMENT = 369,
    CMD_LIST = 370,
    CMD_STOPWATCH = 371,
    RESET = 372,
    CMD_EXPORT = 373,
    CMD_AUTOSTART = 374,
    CMD_AUTOLOAD = 375,
    CMD_MAINCPU_TRACE = 376,
    CMD_WARP = 377,
    CMD_LABEL_ASGN = 378,
    L_PAREN = 379,
    R_PAREN = 380,
    ARG_IMMEDIATE = 381,
    REG_A = 382,
    REG_X = 383,
    REG_Y = 384,
    COMMA = 385,
    INST_SEP = 386,
    L_BRACKET = 387,
    R_BRACKET = 388,
    LESS_THAN = 389,
    REG_U = 390,
    REG_S = 391,
    REG_PC = 392,
    REG_PCR = 393,
    REG_B = 394,
    REG_C = 395,
    REG_D = 396,
    REG_E = 397,
    REG_H = 398,
    REG_L = 399,
    REG_AF = 400,
    REG_BC = 401,
    REG_DE = 402,
    REG_HL = 403,
    REG_IX = 404,
    REG_IY = 405,
    REG_SP = 406,
    REG_IXH = 407,
    REG_IXL = 408,
    REG_IYH = 409,
    REG_IYL = 410,
    PLUS = 411,
    MINUS = 412,
    STRING = 413,
    FILENAME = 414,
    R_O_L = 415,
    R_O_L_Q = 416,
    OPCODE = 417,
    LABEL = 418,
    BANKNAME = 419,
    CPUTYPE = 420,
    MON_REGISTER = 421,
    COND_OP = 422,
    RADIX_TYPE = 423,
    INPUT_SPEC = 424,
    CMD_CHECKPT_ON = 425,
    CMD_CHECKPT_OFF = 426,
    TOGGLE = 427,
    MASK = 428
  };
#endif
/* Tokens.  */
#define H_NUMBER 258
#define D_NUMBER 259
#define O_NUMBER 260
#define B_NUMBER 261
#define CONVERT_OP 262
#define B_DATA 263
#define H_RANGE_GUESS 264
#define D_NUMBER_GUESS 265
#define O_NUMBER_GUESS 266
#define B_NUMBER_GUESS 267
#define BAD_CMD 268
#define MEM_OP 269
#define IF 270
#define MEM_COMP 271
#define MEM_DISK8 272
#define MEM_DISK9 273
#define MEM_DISK10 274
#define MEM_DISK11 275
#define EQUALS 276
#define TRAIL 277
#define CMD_SEP 278
#define LABEL_ASGN_COMMENT 279
#define CMD_LOG 280
#define CMD_LOGNAME 281
#define CMD_SIDEFX 282
#define CMD_DUMMY 283
#define CMD_RETURN 284
#define CMD_BLOCK_READ 285
#define CMD_BLOCK_WRITE 286
#define CMD_UP 287
#define CMD_DOWN 288
#define CMD_LOAD 289
#define CMD_SAVE 290
#define CMD_VERIFY 291
#define CMD_BVERIFY 292
#define CMD_IGNORE 293
#define CMD_HUNT 294
#define CMD_FILL 295
#define CMD_MOVE 296
#define CMD_GOTO 297
#define CMD_REGISTERS 298
#define CMD_READSPACE 299
#define CMD_WRITESPACE 300
#define CMD_RADIX 301
#define CMD_MEM_DISPLAY 302
#define CMD_BREAK 303
#define CMD_TRACE 304
#define CMD_IO 305
#define CMD_BRMON 306
#define CMD_COMPARE 307
#define CMD_DUMP 308
#define CMD_UNDUMP 309
#define CMD_EXIT 310
#define CMD_DELETE 311
#define CMD_CONDITION 312
#define CMD_COMMAND 313
#define CMD_ASSEMBLE 314
#define CMD_DISASSEMBLE 315
#define CMD_NEXT 316
#define CMD_STEP 317
#define CMD_PRINT 318
#define CMD_DEVICE 319
#define CMD_HELP 320
#define CMD_WATCH 321
#define CMD_DISK 322
#define CMD_QUIT 323
#define CMD_CHDIR 324
#define CMD_BANK 325
#define CMD_LOAD_LABELS 326
#define CMD_SAVE_LABELS 327
#define CMD_ADD_LABEL 328
#define CMD_DEL_LABEL 329
#define CMD_SHOW_LABELS 330
#define CMD_CLEAR_LABELS 331
#define CMD_RECORD 332
#define CMD_MON_STOP 333
#define CMD_PLAYBACK 334
#define CMD_CHAR_DISPLAY 335
#define CMD_SPRITE_DISPLAY 336
#define CMD_TEXT_DISPLAY 337
#define CMD_SCREENCODE_DISPLAY 338
#define CMD_ENTER_DATA 339
#define CMD_ENTER_BIN_DATA 340
#define CMD_KEYBUF 341
#define CMD_BLOAD 342
#define CMD_BSAVE 343
#define CMD_SCREEN 344
#define CMD_UNTIL 345
#define CMD_CPU 346
#define CMD_YYDEBUG 347
#define CMD_BACKTRACE 348
#define CMD_SCREENSHOT 349
#define CMD_PWD 350
#define CMD_DIR 351
#define CMD_MKDIR 352
#define CMD_RMDIR 353
#define CMD_RESOURCE_GET 354
#define CMD_RESOURCE_SET 355
#define CMD_LOAD_RESOURCES 356
#define CMD_SAVE_RESOURCES 357
#define CMD_ATTACH 358
#define CMD_DETACH 359
#define CMD_MON_RESET 360
#define CMD_TAPECTRL 361
#define CMD_CARTFREEZE 362
#define CMD_UPDB 363
#define CMD_JPDB 364
#define CMD_CPUHISTORY 365
#define CMD_MEMMAPZAP 366
#define CMD_MEMMAPSHOW 367
#define CMD_MEMMAPSAVE 368
#define CMD_COMMENT 369
#define CMD_LIST 370
#define CMD_STOPWATCH 371
#define RESET 372
#define CMD_EXPORT 373
#define CMD_AUTOSTART 374
#define CMD_AUTOLOAD 375
#define CMD_MAINCPU_TRACE 376
#define CMD_WARP 377
#define CMD_LABEL_ASGN 378
#define L_PAREN 379
#define R_PAREN 380
#define ARG_IMMEDIATE 381
#define REG_A 382
#define REG_X 383
#define REG_Y 384
#define COMMA 385
#define INST_SEP 386
#define L_BRACKET 387
#define R_BRACKET 388
#define LESS_THAN 389
#define REG_U 390
#define REG_S 391
#define REG_PC 392
#define REG_PCR 393
#define REG_B 394
#define REG_C 395
#define REG_D 396
#define REG_E 397
#define REG_H 398
#define REG_L 399
#define REG_AF 400
#define REG_BC 401
#define REG_DE 402
#define REG_HL 403
#define REG_IX 404
#define REG_IY 405
#define REG_SP 406
#define REG_IXH 407
#define REG_IXL 408
#define REG_IYH 409
#define REG_IYL 410
#define PLUS 411
#define MINUS 412
#define STRING 413
#define FILENAME 414
#define R_O_L 415
#define R_O_L_Q 416
#define OPCODE 417
#define LABEL 418
#define BANKNAME 419
#define CPUTYPE 420
#define MON_REGISTER 421
#define COND_OP 422
#define RADIX_TYPE 423
#define INPUT_SPEC 424
#define CMD_CHECKPT_ON 425
#define CMD_CHECKPT_OFF 426
#define TOGGLE 427
#define MASK 428

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 139 "mon_parse.y" /* yacc.c:355  */

    MON_ADDR a;
    MON_ADDR range[2];
    int i;
    REG_ID reg;
    CONDITIONAL cond_op;
    cond_node_t *cond_node;
    RADIXTYPE rt;
    ACTION action;
    char *str;
    asm_mode_addr_info_t mode;

#line 603 "mon_parse.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_MON_PARSE_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 620 "mon_parse.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  336
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1857

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  182
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  56
/* YYNRULES -- Number of rules.  */
#define YYNRULES  340
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  695

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   428

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     178,   179,   176,   174,     2,   175,     2,   177,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   181,     2,
       2,     2,     2,     2,   180,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   204,   204,   205,   206,   209,   210,   213,   214,   215,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   233,   235,   237,   239,   241,   243,   245,
     247,   249,   251,   253,   255,   257,   259,   261,   263,   265,
     267,   269,   271,   273,   275,   277,   279,   281,   283,   285,
     287,   289,   291,   293,   295,   297,   299,   301,   303,   308,
     312,   315,   317,   319,   322,   327,   332,   334,   336,   338,
     340,   342,   344,   346,   348,   350,   354,   361,   360,   363,
     365,   367,   371,   373,   375,   377,   379,   381,   383,   385,
     387,   389,   391,   393,   395,   397,   399,   401,   403,   405,
     407,   409,   413,   422,   425,   429,   432,   441,   444,   453,
     458,   460,   462,   464,   466,   468,   470,   472,   474,   476,
     478,   482,   484,   489,   496,   504,   511,   523,   527,   529,
     547,   549,   551,   553,   555,   557,   561,   563,   565,   567,
     569,   571,   573,   575,   577,   579,   581,   583,   585,   587,
     589,   591,   593,   595,   597,   599,   601,   603,   605,   607,
     609,   611,   613,   617,   619,   621,   623,   625,   627,   629,
     631,   633,   635,   637,   639,   641,   643,   645,   647,   649,
     651,   653,   655,   657,   661,   663,   665,   669,   671,   675,
     679,   682,   683,   686,   689,   690,   693,   694,   697,   698,
     701,   702,   705,   711,   719,   720,   723,   727,   728,   731,
     732,   735,   736,   738,   742,   743,   746,   751,   756,   766,
     767,   770,   771,   772,   773,   774,   777,   779,   781,   782,
     783,   784,   785,   786,   787,   790,   791,   793,   798,   800,
     802,   804,   808,   814,   820,   832,   833,   836,   837,   840,
     841,   844,   845,   846,   849,   850,   853,   854,   855,   856,
     859,   860,   861,   864,   865,   866,   867,   868,   871,   872,
     873,   876,   886,   887,   890,   897,   908,   919,   927,   946,
     952,   960,   968,   970,   972,   973,   974,   975,   976,   977,
     978,   980,   982,   984,   986,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1006,  1007,  1022,  1026,  1030,  1034,  1038,
    1042,  1046,  1050,  1054,  1066,  1081,  1085,  1089,  1093,  1097,
    1101,  1105,  1109,  1113,  1125,  1130,  1138,  1139,  1140,  1141,
    1145
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "H_NUMBER", "D_NUMBER", "O_NUMBER",
  "B_NUMBER", "CONVERT_OP", "B_DATA", "H_RANGE_GUESS", "D_NUMBER_GUESS",
  "O_NUMBER_GUESS", "B_NUMBER_GUESS", "BAD_CMD", "MEM_OP", "IF",
  "MEM_COMP", "MEM_DISK8", "MEM_DISK9", "MEM_DISK10", "MEM_DISK11",
  "EQUALS", "TRAIL", "CMD_SEP", "LABEL_ASGN_COMMENT", "CMD_LOG",
  "CMD_LOGNAME", "CMD_SIDEFX", "CMD_DUMMY", "CMD_RETURN", "CMD_BLOCK_READ",
  "CMD_BLOCK_WRITE", "CMD_UP", "CMD_DOWN", "CMD_LOAD", "CMD_SAVE",
  "CMD_VERIFY", "CMD_BVERIFY", "CMD_IGNORE", "CMD_HUNT", "CMD_FILL",
  "CMD_MOVE", "CMD_GOTO", "CMD_REGISTERS", "CMD_READSPACE",
  "CMD_WRITESPACE", "CMD_RADIX", "CMD_MEM_DISPLAY", "CMD_BREAK",
  "CMD_TRACE", "CMD_IO", "CMD_BRMON", "CMD_COMPARE", "CMD_DUMP",
  "CMD_UNDUMP", "CMD_EXIT", "CMD_DELETE", "CMD_CONDITION", "CMD_COMMAND",
  "CMD_ASSEMBLE", "CMD_DISASSEMBLE", "CMD_NEXT", "CMD_STEP", "CMD_PRINT",
  "CMD_DEVICE", "CMD_HELP", "CMD_WATCH", "CMD_DISK", "CMD_QUIT",
  "CMD_CHDIR", "CMD_BANK", "CMD_LOAD_LABELS", "CMD_SAVE_LABELS",
  "CMD_ADD_LABEL", "CMD_DEL_LABEL", "CMD_SHOW_LABELS", "CMD_CLEAR_LABELS",
  "CMD_RECORD", "CMD_MON_STOP", "CMD_PLAYBACK", "CMD_CHAR_DISPLAY",
  "CMD_SPRITE_DISPLAY", "CMD_TEXT_DISPLAY", "CMD_SCREENCODE_DISPLAY",
  "CMD_ENTER_DATA", "CMD_ENTER_BIN_DATA", "CMD_KEYBUF", "CMD_BLOAD",
  "CMD_BSAVE", "CMD_SCREEN", "CMD_UNTIL", "CMD_CPU", "CMD_YYDEBUG",
  "CMD_BACKTRACE", "CMD_SCREENSHOT", "CMD_PWD", "CMD_DIR", "CMD_MKDIR",
  "CMD_RMDIR", "CMD_RESOURCE_GET", "CMD_RESOURCE_SET",
  "CMD_LOAD_RESOURCES", "CMD_SAVE_RESOURCES", "CMD_ATTACH", "CMD_DETACH",
  "CMD_MON_RESET", "CMD_TAPECTRL", "CMD_CARTFREEZE", "CMD_UPDB",
  "CMD_JPDB", "CMD_CPUHISTORY", "CMD_MEMMAPZAP", "CMD_MEMMAPSHOW",
  "CMD_MEMMAPSAVE", "CMD_COMMENT", "CMD_LIST", "CMD_STOPWATCH", "RESET",
  "CMD_EXPORT", "CMD_AUTOSTART", "CMD_AUTOLOAD", "CMD_MAINCPU_TRACE",
  "CMD_WARP", "CMD_LABEL_ASGN", "L_PAREN", "R_PAREN", "ARG_IMMEDIATE",
  "REG_A", "REG_X", "REG_Y", "COMMA", "INST_SEP", "L_BRACKET", "R_BRACKET",
  "LESS_THAN", "REG_U", "REG_S", "REG_PC", "REG_PCR", "REG_B", "REG_C",
  "REG_D", "REG_E", "REG_H", "REG_L", "REG_AF", "REG_BC", "REG_DE",
  "REG_HL", "REG_IX", "REG_IY", "REG_SP", "REG_IXH", "REG_IXL", "REG_IYH",
  "REG_IYL", "PLUS", "MINUS", "STRING", "FILENAME", "R_O_L", "R_O_L_Q",
  "OPCODE", "LABEL", "BANKNAME", "CPUTYPE", "MON_REGISTER", "COND_OP",
  "RADIX_TYPE", "INPUT_SPEC", "CMD_CHECKPT_ON", "CMD_CHECKPT_OFF",
  "TOGGLE", "MASK", "'+'", "'-'", "'*'", "'/'", "'('", "')'", "'@'", "':'",
  "$accept", "top_level", "command_list", "end_cmd", "command",
  "machine_state_rules", "register_mod", "symbol_table_rules", "asm_rules",
  "$@1", "memory_rules", "checkpoint_rules", "checkpoint_control_rules",
  "monitor_state_rules", "monitor_misc_rules", "disk_rules",
  "cmd_file_rules", "data_entry_rules", "monitor_debug_rules",
  "rest_of_line", "opt_rest_of_line", "rest_of_line_or_quoted", "filename",
  "device_num", "mem_op", "opt_mem_op", "register", "reg_list", "reg_asgn",
  "checkpt_num", "address_opt_range", "address_range", "opt_address",
  "address", "opt_sep", "memspace", "memloc", "memaddr", "expression",
  "opt_if_cond_expr", "cond_expr", "cond_operand", "data_list",
  "data_element", "hunt_list", "hunt_element", "value", "d_number",
  "guess_default", "number", "assembly_instr_list", "assembly_instruction",
  "post_assemble", "asm_operand_mode", "index_reg", "index_ureg", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    43,    45,    42,    47,    40,    41,
      64,    58
};
# endif

#define YYPACT_NINF -394

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-394)))

#define YYTABLE_NINF -221

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1263,   591,  -394,  -394,     6,     9,    21,    88,   169,   591,
     591,   821,   821,     9,     9,     9,     9,   680,  1123,  1123,
    1123,  1255,   133,    46,  1101,  1225,  1225,  1255,  1123,     9,
       9,   169,  1185,   680,   680,  1639,  1386,   821,   821,   591,
    1161,   179,  1225,  -136,   169,  -128,   521,    87,    87,  1639,
     371,  1161,  1161,     9,   169,     9,  1386,  1386,  1386,  1386,
    1639,   169,  -136,     9,     9,  1255,  1386,   108,   169,   169,
       9,   169,  -111,  -128,  -128,   -88,   -82,     9,     9,     9,
     591,   821,   -52,   169,  1409,  1409,  1149,   169,   821,     9,
    -111,  1199,   355,   169,     9,     9,   -75,    92,    69,  1680,
    1185,  1185,   113,  1410,  -394,  -394,  -394,  -394,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,    99,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,
    -394,  -394,   591,  -394,   -44,   239,  -394,  -394,  -394,  -394,
    -394,  -394,   169,  -394,  -394,  -394,   169,   169,  -394,   169,
    -394,  -394,   923,   923,  -394,  -394,   591,  -394,   591,   720,
     946,   720,   720,  -394,  -394,  -394,  -394,  -394,   821,  -394,
    -394,  -394,   -52,   -52,   -52,  -394,  -394,  -394,   -52,   -52,
    -394,   169,   -52,  -394,   111,   358,  -394,   172,   169,  -394,
     -52,  -394,   169,  -394,   385,  -394,  -394,   114,  1123,  -394,
    1123,  -394,   169,   -52,   169,   169,  -394,   182,  -394,   169,
     127,     7,   138,  -394,   169,  -394,   591,  -394,   591,   239,
    -394,   169,  -394,  -394,   169,  -394,  1123,   169,  -394,  -394,
     169,   169,  -394,   279,   169,   -52,   169,   -52,   -52,   169,
     -52,  -394,   169,  -394,   169,   169,  -394,   169,  -394,   169,
    -394,   169,  -394,   169,  -394,   169,   628,  -394,   169,   720,
     720,  -394,   169,  -394,   169,   169,  -394,  -394,  -394,   821,
    -394,  -394,   169,   169,   169,   169,   -12,   169,   169,   591,
     239,  -394,   591,   591,  -394,   169,  1409,  -394,   986,  -394,
    -394,   591,   -52,   169,   360,  -394,   169,  -394,   169,  -394,
    -394,  1727,  1727,   169,   169,  -394,  1639,  1690,  1409,    18,
     417,  1074,  1409,    29,  -394,    41,  -394,  -394,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,
      42,  -394,  -394,   169,  -394,   169,  -394,  -394,  -394,   107,
    -394,   591,   591,   591,   591,  -394,  -394,  -394,  -394,  -394,
     188,   880,   239,   239,  -394,   400,  1534,  1554,   400,  1601,
    -394,   591,   808,  1639,  1700,   628,  1639,  -394,  1409,  1409,
     350,  -394,  -394,  -394,  1123,  -394,  -394,   159,   159,  -394,
    1639,  -394,  -394,  -394,   742,   169,    19,  -394,    14,  -394,
     239,   239,  -394,  -394,  -394,   159,  -394,  -394,  -394,  -394,
      23,  -394,     9,  -394,     9,    34,  -394,    37,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  1659,  -394,  -394,
    -394,  1621,  1581,  -394,  -394,  -394,  -394,   591,  -394,  -394,
    -394,  -394,   169,  -394,  -394,   239,  -394,   239,   239,  -394,
     169,   566,   566,   859,   591,  -394,  -394,  -394,  -394,  1409,
    -394,  1409,  -394,  -394,   429,    82,    84,    91,    94,    95,
      97,   -51,  -394,   477,  -394,  -394,  -394,  -394,   717,    61,
    -394,    93,   774,    96,   104,     5,  -394,   477,   477,  1715,
    -394,  -394,  -394,  -394,  -164,  -164,  -394,  -394,   169,  1639,
     169,  -394,  -394,   169,  -394,   169,   169,  -394,   169,   239,
    -394,  -394,  1015,  -394,  -394,  -394,  -394,  -394,  1659,   169,
    -394,  -394,   169,   742,   169,   169,   169,   742,    65,  -394,
     122,  -394,  -394,  -394,   169,   106,   120,   169,  -394,  -394,
     169,   169,   169,   169,   169,   169,  -394,   628,  -394,   169,
    -394,   169,   239,  -394,  -394,  -394,  -394,  -394,  -394,   831,
    -394,   831,  -394,   169,   239,   169,   169,   169,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,   105,   -64,  -394,   477,  -394,
      86,   477,   788,  -129,   477,   477,   435,   123,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,    77,
    -394,  -394,  -394,     2,    73,   789,  -394,  -394,    14,    14,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,
    -394,   566,   566,  -394,  -394,  -394,  -394,  -394,   291,   132,
     140,  -394,  -394,   137,   477,   155,  -394,  -119,   158,   160,
     161,   175,   181,  -394,  -394,  1639,  -394,  -394,  -394,  -394,
    -394,   831,  -394,   831,  -394,  -394,  -394,  -394,  -394,  -394,
     186,  -394,   184,  -394,  -394,   189,  -394,  -394,  -394,  -394,
    -394,  -394,   566,   566,   190,  -394,  -394,  -394,   831,  -394,
     831,  -394,   566,   566,  -394,   831,  -394,   831,   169,   566,
    -394,  -394,   831,   169,  -394
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,    22,     4,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   220,     0,     0,     0,     0,     0,     0,     0,
     192,     0,     0,     0,     0,     0,     0,     0,     0,   294,
       0,     0,     0,     2,     5,    10,    60,    11,    13,    12,
      14,    15,    16,    17,    18,    19,    20,    21,     0,   263,
     264,   265,   266,   262,   261,   260,   221,   222,   223,   224,
     225,   202,     0,   255,     0,     0,   234,   267,   254,     9,
       8,     7,     0,   126,   195,   194,     0,     0,   122,     0,
     124,    45,     0,     0,   219,    52,     0,    54,     0,     0,
       0,     0,     0,   208,   256,   259,   258,   257,     0,   207,
     212,   218,   220,   220,   220,   216,   226,   227,   220,   220,
      28,     0,   220,    61,     0,     0,   205,     0,     0,   129,
     220,    88,     0,   209,   220,   199,   103,   200,     0,   109,
       0,    29,     0,   220,     0,     0,   134,     9,   117,     0,
       0,     0,     0,    81,     0,    50,     0,    48,     0,     0,
     130,     0,   190,   138,     0,   107,     0,     0,   133,   193,
       0,     0,    23,     0,     0,   220,     0,   220,   220,     0,
     220,    72,     0,    74,     0,     0,   185,     0,    90,     0,
      92,     0,    94,     0,    96,     0,     0,   188,     0,     0,
       0,    56,     0,   105,     0,     0,    31,   189,   143,     0,
     145,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   154,     0,     0,   157,     0,     0,    33,     0,    97,
      98,     0,   220,     0,     9,   176,     0,   196,     0,   162,
     132,     0,     0,     0,     0,    58,     0,     0,     0,   295,
       0,     0,     0,   296,   297,   298,   299,   300,   303,   306,
     307,   308,   309,   310,   311,   312,   301,   304,   302,   305,
     275,   271,   111,     0,   113,     0,     1,     6,     3,     0,
     203,     0,     0,     0,     0,   140,   125,   127,   121,   123,
     220,     0,     0,     0,   197,   220,   167,     0,   220,     0,
     114,     0,     0,     0,     0,     0,     0,    27,     0,     0,
       0,    63,    62,   128,     0,    87,   198,   236,   236,    30,
       0,    46,    47,   116,     0,     0,     0,    79,     0,    80,
       0,     0,   137,   131,   139,   236,   136,   141,    25,    24,
       0,    65,     0,    67,     0,     0,    69,     0,    71,    73,
     184,   186,    89,    91,    93,    95,   248,     0,   246,   247,
     142,     0,     0,    57,   104,    32,   148,     0,   144,   146,
     147,   150,     0,   152,   153,     0,   179,     0,     0,   158,
       0,     0,     0,     0,     0,   160,   177,   161,   180,     0,
     182,     0,   135,    59,     0,     0,     0,     0,     0,     0,
       0,     0,   274,     0,   336,   337,   340,   339,     0,   319,
     338,     0,     0,     0,     0,     0,   313,     0,     0,     0,
     110,   112,   233,   232,   228,   229,   230,   231,     0,     0,
       0,    53,    55,     0,   168,     0,     0,   173,     0,     0,
     253,   252,     0,   250,   251,   211,   213,   217,     0,     0,
     206,   204,     0,     0,     0,     0,     0,     0,     0,   242,
       0,   241,   243,   120,     0,   273,   272,     0,    51,    49,
       0,     0,     0,     0,     0,     0,   187,     0,   165,     0,
     170,     0,     0,   151,   178,   155,   156,   159,    34,     0,
      39,     0,    99,     0,     0,     0,     0,     0,    75,   284,
     285,   286,   287,   288,   289,   280,     0,   321,     0,   317,
     315,     0,     0,     0,     0,     0,     0,   334,   320,   322,
     276,   277,   278,   323,   279,   314,   174,   214,   175,   163,
     166,   171,   172,   115,    85,   249,    84,    82,    86,   235,
     102,   108,    83,     0,     0,     0,   118,   119,     0,   270,
      78,   106,    26,    64,    66,    68,    70,   245,   164,   169,
     149,     0,     0,   100,   101,   181,   183,    76,     0,     0,
       0,   318,   316,     0,     0,     0,   329,     0,     0,     0,
       0,     0,     0,   240,   239,     0,   238,   237,   268,   269,
      35,     0,    40,     0,   290,   283,   291,   292,   293,   281,
       0,   331,     0,   327,   325,     0,   330,   332,   333,   324,
     335,   244,     0,     0,     0,   328,   326,    36,     0,    41,
       0,   282,     0,     0,    37,     0,    42,     0,     0,     0,
      38,    43,     0,     0,    44
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -394,  -394,  -394,    -6,   221,  -394,  -394,  -394,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,    11,
     236,    28,   686,   511,  -394,    -3,   -13,  -394,   -42,   546,
     219,    38,  -201,    98,   387,   285,  -272,  -394,    32,  -311,
    -393,  -394,   -35,  -197,  -394,  -154,  -394,    66,  -394,   703,
    -394,  -377,  -394,  -394,   151,  -130
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   102,   103,   143,   104,   105,   106,   107,   108,   388,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   224,
     272,   230,   146,   296,   197,   198,   133,   185,   186,   168,
     192,   193,   488,   194,   489,   134,   175,   176,   135,   514,
     520,   521,   417,   418,   502,   503,   136,   297,   137,   177,
     525,   118,   527,   331,   469,   470
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     148,   150,   151,   643,   636,   155,   157,   139,   385,   184,
     144,   526,   343,   344,   664,   180,   183,   189,   191,   196,
     199,   201,   139,   200,   222,   206,   208,   637,   140,   141,
     213,   215,   217,   229,   220,   223,   225,   665,   228,   226,
     232,   152,   153,   140,   141,   241,   243,   139,   246,   271,
     248,   250,   252,   254,   227,   257,   172,   178,   179,   261,
     263,   266,   267,   268,   629,   270,   203,   515,   140,   141,
     275,   219,   630,   258,   565,   281,   276,   284,   154,   566,
     287,   289,   290,   169,   530,   295,   299,   300,   144,   139,
     306,   305,   507,   139,   332,   334,   507,   303,   169,   169,
     169,   273,   274,   126,   127,   128,   129,   130,   482,   139,
     140,   141,   280,   336,   140,   141,   173,   173,   173,   181,
     599,   338,   340,   139,   603,   202,   173,   644,   376,   345,
     140,   141,   369,   212,   139,   576,   346,   154,   577,   139,
     347,   348,   384,   349,   140,   141,   432,   238,   463,   126,
     127,   128,   129,   130,   493,   140,   141,   496,   256,   477,
     140,   141,   360,   262,   339,  -220,   169,   169,   145,   605,
     139,   478,   479,   139,   513,   367,    99,   524,   142,   371,
     139,   372,   373,  -208,   350,   351,   375,   531,   352,  -215,
     353,   140,   141,   147,   140,   141,   379,   534,   381,   382,
     535,   140,   141,   383,  -208,  -208,   387,   559,   389,   560,
    -215,  -215,   647,   392,   188,   393,   561,   570,   394,   562,
     563,   396,   564,   571,   397,   398,   574,   399,   401,   604,
     403,   648,   649,   406,   575,   628,   408,   608,   409,   410,
     139,   411,   632,   412,   605,   413,   145,   414,   390,   415,
     391,   609,   420,   642,   645,   214,   423,   659,   424,   425,
     149,   140,   141,   426,   304,   660,   428,   429,   430,   431,
     661,   433,   434,   265,   436,   249,   251,   253,   255,   439,
     139,   341,   342,   343,   344,   264,   483,   445,   663,   605,
     446,   666,   447,   667,   668,   448,   450,   452,   453,   131,
     -77,   140,   141,   174,   174,   174,   182,   187,   669,   174,
     670,   435,   182,   174,   437,   438,   674,   675,   154,   681,
     182,   174,   676,   443,   337,   221,   293,   480,   511,   481,
     508,   233,   235,   237,   182,   240,   242,   244,   340,   222,
     617,   174,   174,   174,   174,   182,   491,   492,   595,   585,
     182,   174,     0,     0,   442,     0,   139,   184,     0,   139,
       0,  -197,   341,   342,   343,   344,   126,   127,   128,   129,
     130,   519,     0,   484,   485,   486,   487,   140,   141,   523,
     140,   141,  -197,  -197,   528,   529,  -210,   126,   127,   128,
     129,   130,     0,   499,     0,   495,     0,     0,   156,   158,
    -210,  -215,     0,     0,   454,     0,     0,  -210,  -210,   154,
       0,   536,     0,   341,   342,   343,   344,   377,   654,   378,
     655,     0,  -215,  -215,   216,   218,   543,     0,     0,   544,
     139,   545,   546,     0,   547,   548,   550,   552,     0,   656,
     657,   658,     0,  -220,     0,   395,     0,     0,   558,   490,
       0,   140,   141,   557,     0,   173,     0,   498,     0,   542,
     541,   505,     0,     0,   509,     0,     0,     0,   282,   283,
       0,     0,   298,   288,     0,   291,   554,     0,   516,     0,
       0,     0,   586,   174,   588,   174,     0,   589,   370,   590,
     591,     0,   592,   593,     0,     0,   594,     0,     0,     0,
     519,     0,   596,   597,   519,     0,   598,     0,   600,   601,
     602,   174,     0,     0,   606,   154,   131,     0,   607,   539,
     173,   610,   139,     0,   611,   612,   613,   614,   615,   616,
     154,     0,     0,   618,   239,   619,   620,   126,   127,   128,
     129,   130,     0,   140,   141,   464,   465,   623,   624,   625,
     626,   627,   466,   467,     0,   361,     0,     0,     0,   362,
     363,   364,     0,   464,   465,   365,   366,   139,     0,   368,
     466,   467,   640,   441,   468,     0,     0,   374,   209,   210,
     211,   363,  -220,  -220,  -220,  -220,  -220,   587,   140,   141,
     380,   182,   519,   512,   119,   120,   121,   122,   386,     0,
       0,   123,   124,   125,     0,   464,   465,   126,   127,   128,
     129,   130,   466,   467,   567,   650,   652,     0,     0,   569,
     400,     0,   402,   573,   404,   405,     0,   407,   578,   579,
       0,   119,   120,   121,   122,     0,   182,     0,   123,   124,
     125,     0,   174,     0,   182,     0,   333,   335,   182,     0,
       0,   182,     0,     0,     0,     0,   427,     0,     0,   174,
       0,     0,   553,     0,     0,   182,   677,   679,     0,     0,
     355,   357,   358,   359,     0,     0,   684,   686,     0,   444,
       0,   163,   690,   691,   164,   231,     0,   694,   449,   451,
     165,   166,   167,     0,     0,     0,   154,     0,     0,   159,
     160,   161,   162,     0,   138,     0,   182,   174,     0,     0,
       0,     0,   138,   138,     0,   204,   205,     0,     0,   631,
       0,   354,   633,   635,   164,   638,   639,   641,   174,     0,
     165,   166,   167,   234,   236,     0,     0,     0,     0,   245,
       0,   247,   138,   671,     0,   119,   120,   121,   122,   259,
     260,     0,   123,   124,   125,     0,   269,   131,   126,   127,
     128,   129,   130,   277,   278,   279,     0,     0,     0,   132,
     421,   422,     0,     0,   182,   292,     0,     0,     0,     0,
     301,   302,     0,   138,     0,   662,   416,   285,   286,     0,
     646,     0,   119,   120,   121,   122,     0,     0,     0,   123,
     124,   125,   330,     0,   537,   126,   127,   128,   129,   130,
       0,   119,   120,   121,   122,     0,     0,     0,   123,   124,
     125,     0,   139,     0,  -220,  -220,  -220,  -220,   549,   551,
       0,  -220,  -220,  -220,   621,   138,   622,  -220,  -220,  -220,
    -220,  -220,     0,   140,   141,   464,   465,   126,   127,   128,
     129,   130,   466,   467,     0,   138,   138,     0,     0,   138,
     139,   138,   119,   120,   121,   122,   517,     0,   170,   123,
     124,   125,     0,     0,   568,   126,   127,   128,   129,   130,
       0,   140,   141,   119,   120,   121,   122,     0,     0,     0,
     123,   124,   125,     0,     0,   537,   126,   127,   128,   129,
     130,     0,   464,   465,     0,     0,     0,     0,   131,   466,
     467,     0,     0,   517,     0,     0,   464,   465,     0,   138,
       0,   138,   518,   466,   467,     0,   119,   120,   121,   122,
     182,   572,     0,   123,   124,   125,   672,     0,   673,   126,
     127,   128,   129,   130,     0,   634,     0,   356,     0,     0,
     164,   154,     0,     0,     0,   131,   165,   166,   167,   419,
       0,     0,     0,   682,     0,   683,   500,     0,     0,   518,
     688,     0,   689,     0,     0,     0,     0,   693,     0,     0,
       0,   501,   138,     0,     0,   138,   138,  -220,     0,   440,
     164,     0,     0,     0,   138,     0,   165,   166,   167,  -220,
       0,     0,   126,   127,   128,   129,   130,     0,   651,   653,
     461,   462,     0,     0,   475,   476,   139,     0,   119,   120,
     121,   122,   171,     0,     0,   123,   124,   125,     0,     0,
       0,     0,     0,   341,   342,   343,   344,   140,   141,     0,
       0,     0,     0,   171,   138,   138,   138,   138,     0,     0,
       0,     0,     0,     0,   341,   342,   343,   344,     0,   678,
     680,     0,     0,     0,   138,   504,     0,     0,   419,   685,
     687,     0,   510,     0,     0,     0,   692,   119,   120,   121,
     122,     0,     0,     0,   123,   124,   125,   522,   532,   131,
     533,     0,     0,     0,     0,     0,     0,   341,   342,   343,
     344,   132,   139,     0,   119,   120,   121,   122,     0,     0,
     170,   123,   124,   125,     0,     0,     0,   126,   127,   128,
     129,   130,     0,   140,   141,     0,   119,   120,   121,   122,
     138,     0,   170,   123,   124,   125,     0,     0,     0,   126,
     127,   128,   129,   130,     0,     0,     0,   138,     0,     0,
     139,     0,   555,  -220,   556,     0,     0,     0,     0,  -220,
    -220,  -220,   139,     0,     0,  -220,  -220,  -220,  -220,  -220,
       0,   140,   141,   500,     0,     0,     0,   126,   127,   128,
     129,   130,   584,   140,   141,     0,   207,     0,   501,   164,
       0,     0,     0,     0,     0,   165,   166,   167,     0,     0,
     294,   471,     0,   164,   472,   504,     0,   140,   141,   165,
     166,   167,     0,   473,     0,   474,   522,     0,     0,     0,
     522,   140,   141,     0,     0,     0,   139,     0,  -201,  -201,
    -201,  -201,     0,     0,  -201,  -201,  -201,  -201,     0,   195,
     419,  -201,  -201,  -201,  -201,  -201,     0,   140,   141,     0,
       0,     0,     0,     0,     0,     0,   139,     0,   119,   120,
     121,   122,     0,     0,   171,   123,   124,   125,     0,   190,
       1,   126,   127,   128,   129,   130,     2,   140,   141,   154,
       0,     0,     0,     0,     0,     3,   171,     0,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,     0,   522,    23,
      24,    25,    26,    27,     0,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
       0,    93,    94,    95,    96,    97,    98,   139,  -201,   119,
     120,   121,   122,     0,     0,   170,   123,   124,   125,     0,
       0,     0,   126,   127,   128,   129,   130,     0,   140,   141,
       0,     0,   119,   120,   121,   122,     0,     1,   171,   123,
     124,   125,     0,     2,     0,    99,     0,     0,     0,     0,
       0,     0,     0,   100,   101,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,     0,     0,    23,    24,    25,    26,
      27,     0,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,     0,    93,    94,
      95,    96,    97,    98,     0,  -197,     0,  -197,  -197,  -197,
    -197,     0,     0,  -197,  -197,  -197,  -197,     0,     0,   171,
    -197,  -197,  -197,  -197,  -197,   494,     0,   119,   120,   121,
     122,     0,     0,   170,   123,   124,   125,     0,     0,     0,
     126,   127,   128,   129,   130,     0,     0,     0,     0,     0,
     100,   101,   540,     0,   119,   120,   121,   122,     0,     0,
     170,   123,   124,   125,     0,     0,     0,   126,   127,   128,
     129,   130,   497,     0,   119,   120,   121,   122,     0,     0,
       0,   123,   124,   125,     0,     0,     0,   126,   127,   128,
     129,   130,   538,     0,   119,   120,   121,   122,     0,     0,
       0,   123,   124,   125,     0,     0,     0,   126,   127,   128,
     129,   130,   119,   120,   121,   122,     0,     0,     0,   123,
     124,   125,     0,     0,     0,   126,   127,   128,   129,   130,
     139,     0,  -220,  -220,  -220,  -220,     0,     0,     0,  -220,
    -220,  -220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   140,   141,   119,   120,   121,   122,     0,     0,     0,
     123,   124,   125,   119,   120,   121,   122,  -197,     0,     0,
     123,   124,   125,   119,   120,   121,   122,     0,     0,   506,
     123,   124,   125,     0,     0,     0,     0,   171,   119,   120,
     121,   122,     0,     0,     0,   123,   124,   125,   139,     0,
    -220,  -220,  -220,  -220,     0,     0,     0,  -220,  -220,  -220,
       0,     0,     0,     0,   171,     0,     0,     0,     0,   140,
     141,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   171,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   171,     0,     0,     0,     0,   154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   171,     0,   307,     0,   308,   309,     0,     0,
     310,     0,   311,     0,   312,     0,     0,  -220,     0,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   455,   456,   457,   458,
     459,   460,     0,   580,   581,     0,     0,     0,     0,     0,
     466,   582,   583,     0,     0,     0,     0,   154
};

static const yytype_int16 yycheck[] =
{
       6,     7,     8,     1,   133,    11,    12,     1,     1,    22,
       1,   388,   176,   177,   133,    21,    22,    23,    24,    25,
      26,    27,     1,    26,   160,    31,    32,   156,    22,    23,
      36,    37,    38,   161,    40,    41,    42,   156,    44,    42,
      46,     9,    10,    22,    23,    51,    52,     1,    54,   160,
      56,    57,    58,    59,    43,    61,    18,    19,    20,    65,
      66,    67,    68,    69,   128,    71,    28,   378,    22,    23,
     158,    39,   136,    62,   125,    81,   158,    83,   130,   130,
      86,    87,    88,    17,   395,    91,    92,    93,     1,     1,
      21,    97,   364,     1,   100,   101,   368,   172,    32,    33,
      34,    73,    74,    16,    17,    18,    19,    20,     1,     1,
      22,    23,    80,     0,    22,    23,    18,    19,    20,    21,
     513,    22,   166,     1,   517,    27,    28,   125,    14,   135,
      22,    23,    21,    35,     1,   130,   142,   130,   133,     1,
     146,   147,    15,   149,    22,    23,   158,    49,   130,    16,
      17,    18,    19,    20,   355,    22,    23,   358,    60,   130,
      22,    23,   168,    65,   132,   158,   100,   101,   159,   167,
       1,   130,   130,     1,    15,   181,   162,   158,   172,   185,
       1,   187,   188,     1,   152,   153,   192,   164,   156,     1,
     158,    22,    23,   172,    22,    23,   202,   163,   204,   205,
     163,    22,    23,   209,    22,    23,   212,   125,   214,   125,
      22,    23,   605,   219,   168,   221,   125,   156,   224,   125,
     125,   227,   125,   130,   230,   231,   130,   233,   234,   164,
     236,   608,   609,   239,   130,   130,   242,   131,   244,   245,
       1,   247,   156,   249,   167,   251,   159,   253,   216,   255,
     218,   131,   258,   130,   181,    36,   262,   125,   264,   265,
     172,    22,    23,   269,   172,   125,   272,   273,   274,   275,
     133,   277,   278,   165,   280,    56,    57,    58,    59,   285,
       1,   174,   175,   176,   177,    66,   179,   293,   133,   167,
     296,   133,   298,   133,   133,   301,   302,   303,   304,   166,
     162,    22,    23,    18,    19,    20,    21,    22,   133,    24,
     129,   279,    27,    28,   282,   283,   130,   133,   130,   129,
      35,    36,   133,   291,   103,    40,    90,   333,   370,   335,
     365,    46,    47,    48,    49,    50,    51,    52,   166,   160,
     537,    56,    57,    58,    59,    60,   352,   353,   502,   479,
      65,    66,    -1,    -1,   288,    -1,     1,   370,    -1,     1,
      -1,     1,   174,   175,   176,   177,    16,    17,    18,    19,
      20,   384,    -1,   341,   342,   343,   344,    22,    23,   385,
      22,    23,    22,    23,   390,   391,     1,    16,    17,    18,
      19,    20,    -1,   361,    -1,   357,    -1,    -1,    11,    12,
      15,     1,    -1,    -1,   306,    -1,    -1,    22,    23,   130,
      -1,   417,    -1,   174,   175,   176,   177,   198,   127,   200,
     129,    -1,    22,    23,    37,    38,   432,    -1,    -1,   435,
       1,   437,   438,    -1,   440,   441,   442,   443,    -1,   148,
     149,   150,    -1,   164,    -1,   226,    -1,    -1,   454,   351,
      -1,    22,    23,    24,    -1,   357,    -1,   359,    -1,   427,
     422,   363,    -1,    -1,   366,    -1,    -1,    -1,    81,    82,
      -1,    -1,   117,    86,    -1,    88,   444,    -1,   380,    -1,
      -1,    -1,   488,   198,   490,   200,    -1,   493,   130,   495,
     496,    -1,   498,   499,    -1,    -1,   502,    -1,    -1,    -1,
     513,    -1,   508,   509,   517,    -1,   512,    -1,   514,   515,
     516,   226,    -1,    -1,   520,   130,   166,    -1,   524,   421,
     422,   527,     1,    -1,   530,   531,   532,   533,   534,   535,
     130,    -1,    -1,   539,   163,   541,   542,    16,    17,    18,
      19,    20,    -1,    22,    23,   128,   129,   553,   554,   555,
     556,   557,   135,   136,    -1,   168,    -1,    -1,    -1,   172,
     173,   174,    -1,   128,   129,   178,   179,     1,    -1,   182,
     135,   136,   137,   288,   157,    -1,    -1,   190,    32,    33,
      34,   194,    16,    17,    18,    19,    20,   489,    22,    23,
     203,   306,   605,   374,     3,     4,     5,     6,   211,    -1,
      -1,    10,    11,    12,    -1,   128,   129,    16,    17,    18,
      19,    20,   135,   136,   463,   621,   622,    -1,    -1,   468,
     233,    -1,   235,   472,   237,   238,    -1,   240,   477,   478,
      -1,     3,     4,     5,     6,    -1,   351,    -1,    10,    11,
      12,    -1,   357,    -1,   359,    -1,   100,   101,   363,    -1,
      -1,   366,    -1,    -1,    -1,    -1,   269,    -1,    -1,   374,
      -1,    -1,   443,    -1,    -1,   380,   672,   673,    -1,    -1,
     159,   160,   161,   162,    -1,    -1,   682,   683,    -1,   292,
      -1,     1,   688,   689,     4,   164,    -1,   693,   301,   302,
      10,    11,    12,    -1,    -1,    -1,   130,    -1,    -1,    13,
      14,    15,    16,    -1,     1,    -1,   421,   422,    -1,    -1,
      -1,    -1,     9,    10,    -1,    29,    30,    -1,    -1,   568,
      -1,     1,   571,   572,     4,   574,   575,   576,   443,    -1,
      10,    11,    12,    47,    48,    -1,    -1,    -1,    -1,    53,
      -1,    55,    39,   645,    -1,     3,     4,     5,     6,    63,
      64,    -1,    10,    11,    12,    -1,    70,   166,    16,    17,
      18,    19,    20,    77,    78,    79,    -1,    -1,    -1,   178,
     259,   260,    -1,    -1,   489,    89,    -1,    -1,    -1,    -1,
      94,    95,    -1,    80,    -1,   634,   158,    84,    85,    -1,
       1,    -1,     3,     4,     5,     6,    -1,    -1,    -1,    10,
      11,    12,    99,    -1,   417,    16,    17,    18,    19,    20,
      -1,     3,     4,     5,     6,    -1,    -1,    -1,    10,    11,
      12,    -1,     1,    -1,     3,     4,     5,     6,   441,   442,
      -1,    10,    11,    12,   549,   132,   551,    16,    17,    18,
      19,    20,    -1,    22,    23,   128,   129,    16,    17,    18,
      19,    20,   135,   136,    -1,   152,   153,    -1,    -1,   156,
       1,   158,     3,     4,     5,     6,   124,    -1,     9,    10,
      11,    12,    -1,    -1,   157,    16,    17,    18,    19,    20,
      -1,    22,    23,     3,     4,     5,     6,    -1,    -1,    -1,
      10,    11,    12,    -1,    -1,   508,    16,    17,    18,    19,
      20,    -1,   128,   129,    -1,    -1,    -1,    -1,   166,   135,
     136,    -1,    -1,   124,    -1,    -1,   128,   129,    -1,   216,
      -1,   218,   180,   135,   136,    -1,     3,     4,     5,     6,
     645,   157,    -1,    10,    11,    12,   651,    -1,   653,    16,
      17,    18,    19,    20,    -1,   157,    -1,     1,    -1,    -1,
       4,   130,    -1,    -1,    -1,   166,    10,    11,    12,   256,
      -1,    -1,    -1,   678,    -1,   680,   158,    -1,    -1,   180,
     685,    -1,   687,    -1,    -1,    -1,    -1,   692,    -1,    -1,
      -1,   173,   279,    -1,    -1,   282,   283,   166,    -1,   286,
       4,    -1,    -1,    -1,   291,    -1,    10,    11,    12,   178,
      -1,    -1,    16,    17,    18,    19,    20,    -1,   621,   622,
     307,   308,    -1,    -1,   311,   312,     1,    -1,     3,     4,
       5,     6,   163,    -1,    -1,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    22,    23,    -1,
      -1,    -1,    -1,   163,   341,   342,   343,   344,    -1,    -1,
      -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   672,
     673,    -1,    -1,    -1,   361,   362,    -1,    -1,   365,   682,
     683,    -1,   369,    -1,    -1,    -1,   689,     3,     4,     5,
       6,    -1,    -1,    -1,    10,    11,    12,   384,   402,   166,
     404,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,   178,     1,    -1,     3,     4,     5,     6,    -1,    -1,
       9,    10,    11,    12,    -1,    -1,    -1,    16,    17,    18,
      19,    20,    -1,    22,    23,    -1,     3,     4,     5,     6,
     427,    -1,     9,    10,    11,    12,    -1,    -1,    -1,    16,
      17,    18,    19,    20,    -1,    -1,    -1,   444,    -1,    -1,
       1,    -1,   449,     4,   451,    -1,    -1,    -1,    -1,    10,
      11,    12,     1,    -1,    -1,    16,    17,    18,    19,    20,
      -1,    22,    23,   158,    -1,    -1,    -1,    16,    17,    18,
      19,    20,   479,    22,    23,    -1,     1,    -1,   173,     4,
      -1,    -1,    -1,    -1,    -1,    10,    11,    12,    -1,    -1,
       1,   127,    -1,     4,   130,   502,    -1,    22,    23,    10,
      11,    12,    -1,   139,    -1,   141,   513,    -1,    -1,    -1,
     517,    22,    23,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,    -1,    -1,     9,    10,    11,    12,    -1,    14,
     537,    16,    17,    18,    19,    20,    -1,    22,    23,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,    -1,    -1,   163,    10,    11,    12,    -1,   168,
       7,    16,    17,    18,    19,    20,    13,    22,    23,   130,
      -1,    -1,    -1,    -1,    -1,    22,   163,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    -1,   605,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
      -1,   118,   119,   120,   121,   122,   123,     1,   163,     3,
       4,     5,     6,    -1,    -1,     9,    10,    11,    12,    -1,
      -1,    -1,    16,    17,    18,    19,    20,    -1,    22,    23,
      -1,    -1,     3,     4,     5,     6,    -1,     7,   163,    10,
      11,    12,    -1,    13,    -1,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   170,   171,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    -1,    -1,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,    -1,   118,   119,
     120,   121,   122,   123,    -1,     1,    -1,     3,     4,     5,
       6,    -1,    -1,     9,    10,    11,    12,    -1,    -1,   163,
      16,    17,    18,    19,    20,     1,    -1,     3,     4,     5,
       6,    -1,    -1,     9,    10,    11,    12,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    -1,
     170,   171,     1,    -1,     3,     4,     5,     6,    -1,    -1,
       9,    10,    11,    12,    -1,    -1,    -1,    16,    17,    18,
      19,    20,     1,    -1,     3,     4,     5,     6,    -1,    -1,
      -1,    10,    11,    12,    -1,    -1,    -1,    16,    17,    18,
      19,    20,     1,    -1,     3,     4,     5,     6,    -1,    -1,
      -1,    10,    11,    12,    -1,    -1,    -1,    16,    17,    18,
      19,    20,     3,     4,     5,     6,    -1,    -1,    -1,    10,
      11,    12,    -1,    -1,    -1,    16,    17,    18,    19,    20,
       1,    -1,     3,     4,     5,     6,    -1,    -1,    -1,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,     3,     4,     5,     6,    -1,    -1,    -1,
      10,    11,    12,     3,     4,     5,     6,   163,    -1,    -1,
      10,    11,    12,     3,     4,     5,     6,    -1,    -1,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,   163,     3,     4,
       5,     6,    -1,    -1,    -1,    10,    11,    12,     1,    -1,
       3,     4,     5,     6,    -1,    -1,    -1,    10,    11,    12,
      -1,    -1,    -1,    -1,   163,    -1,    -1,    -1,    -1,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   163,    -1,    -1,    -1,    -1,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   124,    -1,   126,   127,    -1,    -1,
     130,    -1,   132,    -1,   134,    -1,    -1,   158,    -1,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   146,   147,   148,   149,
     150,   151,    -1,   128,   129,    -1,    -1,    -1,    -1,    -1,
     135,   136,   137,    -1,    -1,    -1,    -1,   130
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     7,    13,    22,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    46,    47,    48,    49,    50,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   118,   119,   120,   121,   122,   123,   162,
     170,   171,   183,   184,   186,   187,   188,   189,   190,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   233,     3,
       4,     5,     6,    10,    11,    12,    16,    17,    18,    19,
      20,   166,   178,   208,   217,   220,   228,   230,   231,     1,
      22,    23,   172,   185,     1,   159,   204,   172,   185,   172,
     185,   185,   220,   220,   130,   185,   216,   185,   216,   204,
     204,   204,   204,     1,     4,    10,    11,    12,   211,   229,
       9,   163,   213,   215,   217,   218,   219,   231,   213,   213,
     185,   215,   217,   185,   208,   209,   210,   217,   168,   185,
     168,   185,   212,   213,   215,    14,   185,   206,   207,   185,
     207,   185,   215,   213,   204,   204,   185,     1,   185,   211,
     211,   211,   215,   185,   212,   185,   216,   185,   216,   220,
     185,   217,   160,   185,   201,   185,   207,   201,   185,   161,
     203,   164,   185,   217,   204,   217,   204,   217,   215,   163,
     217,   185,   217,   185,   217,   204,   185,   204,   185,   212,
     185,   212,   185,   212,   185,   212,   215,   185,   201,   204,
     204,   185,   215,   185,   212,   165,   185,   185,   185,   204,
     185,   160,   202,   203,   203,   158,   158,   204,   204,   204,
     220,   185,   216,   216,   185,   231,   231,   185,   216,   185,
     185,   216,   204,   202,     1,   185,   205,   229,   117,   185,
     185,   204,   204,   172,   172,   185,    21,   124,   126,   127,
     130,   132,   134,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     231,   235,   185,   211,   185,   211,     0,   186,    22,   220,
     166,   174,   175,   176,   177,   185,   185,   185,   185,   185,
     220,   220,   220,   220,     1,   205,     1,   205,   205,   205,
     185,   216,   216,   216,   216,   216,   216,   185,   216,    21,
     130,   185,   185,   185,   216,   185,    14,   212,   212,   185,
     216,   185,   185,   185,    15,     1,   216,   185,   191,   185,
     220,   220,   185,   185,   185,   212,   185,   185,   185,   185,
     216,   185,   216,   185,   216,   216,   185,   216,   185,   185,
     185,   185,   185,   185,   185,   185,   158,   224,   225,   231,
     185,   205,   205,   185,   185,   185,   185,   216,   185,   185,
     185,   185,   158,   185,   185,   220,   185,   220,   220,   185,
     231,   217,   229,   220,   216,   185,   185,   185,   185,   216,
     185,   216,   185,   185,   215,   146,   147,   148,   149,   150,
     151,   231,   231,   130,   128,   129,   135,   136,   157,   236,
     237,   127,   130,   139,   141,   231,   231,   130,   130,   130,
     185,   185,     1,   179,   220,   220,   220,   220,   214,   216,
     215,   185,   185,   214,     1,   213,   214,     1,   215,   220,
     158,   173,   226,   227,   231,   215,     9,   218,   224,   215,
     231,   210,   212,    15,   221,   221,   215,   124,   180,   208,
     222,   223,   231,   185,   158,   232,   233,   234,   185,   185,
     221,   164,   204,   204,   163,   163,   185,   216,     1,   215,
       1,   213,   220,   185,   185,   185,   185,   185,   185,   216,
     185,   216,   185,   212,   220,   231,   231,    24,   185,   125,
     125,   125,   125,   125,   125,   125,   130,   236,   157,   236,
     156,   130,   157,   236,   130,   130,   130,   133,   236,   236,
     128,   129,   136,   137,   231,   237,   185,   215,   185,   185,
     185,   185,   185,   185,   185,   227,   185,   185,   185,   222,
     185,   185,   185,   222,   164,   167,   185,   185,   131,   131,
     185,   185,   185,   185,   185,   185,   185,   225,   185,   185,
     185,   217,   217,   185,   185,   185,   185,   185,   130,   128,
     136,   236,   156,   236,   157,   236,   133,   156,   236,   236,
     137,   236,   130,     1,   125,   181,     1,   222,   233,   233,
     185,   216,   185,   216,   127,   129,   148,   149,   150,   125,
     125,   133,   236,   133,   133,   156,   133,   133,   133,   133,
     129,   215,   217,   217,   130,   133,   133,   185,   216,   185,
     216,   129,   217,   217,   185,   216,   185,   216,   217,   217,
     185,   185,   216,   217,   185
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   182,   183,   183,   183,   184,   184,   185,   185,   185,
     186,   186,   186,   186,   186,   186,   186,   186,   186,   186,
     186,   186,   186,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   188,   188,   188,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   191,   190,   190,
     190,   190,   192,   192,   192,   192,   192,   192,   192,   192,
     192,   192,   192,   192,   192,   192,   192,   192,   192,   192,
     192,   192,   193,   193,   193,   193,   193,   193,   193,   193,
     194,   194,   194,   194,   194,   194,   194,   194,   194,   194,
     194,   195,   195,   195,   195,   195,   195,   195,   195,   195,
     195,   195,   195,   195,   195,   195,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   197,   197,   197,   197,   197,   197,   197,
     197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
     197,   197,   197,   197,   198,   198,   198,   199,   199,   200,
     201,   202,   202,   203,   204,   204,   205,   205,   206,   206,
     207,   207,   208,   208,   209,   209,   210,   211,   211,   212,
     212,   213,   213,   213,   214,   214,   215,   215,   215,   216,
     216,   217,   217,   217,   217,   217,   218,   219,   220,   220,
     220,   220,   220,   220,   220,   221,   221,   222,   222,   222,
     222,   222,   223,   223,   223,   224,   224,   225,   225,   226,
     226,   227,   227,   227,   228,   228,   229,   229,   229,   229,
     230,   230,   230,   231,   231,   231,   231,   231,   232,   232,
     232,   233,   234,   234,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   236,   236,   236,   236,
     237
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     5,     3,     2,     2,
       3,     2,     3,     2,     4,     6,     8,    10,    12,     4,
       6,     8,    10,    12,    14,     2,     3,     3,     2,     4,
       2,     4,     2,     4,     2,     4,     2,     3,     2,     3,
       1,     2,     3,     3,     5,     3,     5,     3,     5,     3,
       5,     3,     2,     3,     2,     4,     5,     0,     5,     3,
       3,     2,     5,     5,     5,     5,     5,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     2,     2,     4,
       5,     5,     5,     2,     3,     2,     5,     2,     5,     2,
       3,     2,     3,     2,     3,     5,     3,     2,     5,     5,
       4,     3,     2,     3,     2,     3,     2,     3,     3,     2,
       2,     3,     2,     2,     2,     3,     3,     3,     2,     3,
       3,     3,     3,     2,     3,     2,     3,     3,     3,     5,
       3,     4,     3,     3,     2,     4,     4,     2,     3,     4,
       3,     3,     2,     5,     5,     4,     5,     3,     4,     5,
       4,     5,     5,     4,     5,     5,     2,     3,     4,     3,
       3,     5,     3,     5,     3,     2,     3,     4,     2,     2,
       1,     1,     0,     1,     1,     1,     1,     1,     2,     1,
       1,     0,     1,     2,     3,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     2,     0,     1,     3,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     1,     2,     0,     3,     3,     3,
       3,     1,     1,     1,     4,     3,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       2,     2,     1,     1,     2,     1,     3,     3,     3,     3,
       3,     5,     7,     5,     3,     3,     3,     3,     3,     3,
       5,     5,     5,     5,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     4,     3,     4,     2,
       3,     3,     3,     3,     5,     5,     6,     5,     6,     4,
       5,     5,     5,     5,     3,     5,     1,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 204 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 2456 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 3:
#line 205 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 2462 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 4:
#line 206 "mon_parse.y" /* yacc.c:1646  */
    { new_cmd = 1; asm_mode = 0;  (yyval.i) = 0; }
#line 2468 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 9:
#line 215 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_END_CMD; }
#line 2474 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 22:
#line 230 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_BAD_CMD; }
#line 2480 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 23:
#line 234 "mon_parse.y" /* yacc.c:1646  */
    { mon_bank(e_default_space, NULL); }
#line 2486 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 24:
#line 236 "mon_parse.y" /* yacc.c:1646  */
    { mon_bank((yyvsp[-1].i), NULL); }
#line 2492 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 25:
#line 238 "mon_parse.y" /* yacc.c:1646  */
    { mon_bank(e_default_space, (yyvsp[-1].str)); }
#line 2498 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 26:
#line 240 "mon_parse.y" /* yacc.c:1646  */
    { mon_bank((yyvsp[-3].i), (yyvsp[-1].str)); }
#line 2504 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 27:
#line 242 "mon_parse.y" /* yacc.c:1646  */
    { mon_jump((yyvsp[-1].a)); }
#line 2510 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 28:
#line 244 "mon_parse.y" /* yacc.c:1646  */
    { mon_go(); }
#line 2516 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 29:
#line 246 "mon_parse.y" /* yacc.c:1646  */
    { mon_display_io_regs(0); }
#line 2522 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 30:
#line 248 "mon_parse.y" /* yacc.c:1646  */
    { mon_display_io_regs((yyvsp[-1].a)); }
#line 2528 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 31:
#line 250 "mon_parse.y" /* yacc.c:1646  */
    { monitor_cpu_type_set(""); }
#line 2534 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 32:
#line 252 "mon_parse.y" /* yacc.c:1646  */
    { monitor_cpu_type_set((yyvsp[-1].str)); }
#line 2540 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 33:
#line 254 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory(-1,  0,  0,  0,   0,   0); }
#line 2546 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 34:
#line 256 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory(-1, (yyvsp[-1].i),  0,  0,   0,   0); }
#line 2552 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 35:
#line 258 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory(-1, (yyvsp[-3].i), (yyvsp[-1].i),  0,   0,   0); }
#line 2558 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 36:
#line 260 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory(-1, (yyvsp[-5].i), (yyvsp[-3].i), (yyvsp[-1].i),   0,   0); }
#line 2564 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 37:
#line 262 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory(-1, (yyvsp[-7].i), (yyvsp[-5].i), (yyvsp[-3].i),  (yyvsp[-1].i),   0); }
#line 2570 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 38:
#line 264 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory(-1, (yyvsp[-9].i), (yyvsp[-7].i), (yyvsp[-5].i),  (yyvsp[-3].i), (yyvsp[-1].i)); }
#line 2576 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 39:
#line 266 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory((yyvsp[-1].i),  0,  0,  0,   0,   0); }
#line 2582 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 40:
#line 268 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory((yyvsp[-3].i), (yyvsp[-1].i),  0,  0,   0,   0); }
#line 2588 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 41:
#line 270 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory((yyvsp[-5].i), (yyvsp[-3].i), (yyvsp[-1].i),  0,   0,   0); }
#line 2594 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 42:
#line 272 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory((yyvsp[-7].i), (yyvsp[-5].i), (yyvsp[-3].i), (yyvsp[-1].i),   0,   0); }
#line 2600 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 43:
#line 274 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory((yyvsp[-9].i), (yyvsp[-7].i), (yyvsp[-5].i), (yyvsp[-3].i), (yyvsp[-1].i),   0); }
#line 2606 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 44:
#line 276 "mon_parse.y" /* yacc.c:1646  */
    { mon_cpuhistory((yyvsp[-11].i), (yyvsp[-9].i), (yyvsp[-7].i), (yyvsp[-5].i), (yyvsp[-3].i), (yyvsp[-1].i)); }
#line 2612 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 45:
#line 278 "mon_parse.y" /* yacc.c:1646  */
    { mon_instruction_return(); }
#line 2618 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 46:
#line 280 "mon_parse.y" /* yacc.c:1646  */
    { mon_write_snapshot((yyvsp[-1].str),0,0,0); /* FIXME */ }
#line 2624 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 47:
#line 282 "mon_parse.y" /* yacc.c:1646  */
    { mon_read_snapshot((yyvsp[-1].str), 0); }
#line 2630 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 48:
#line 284 "mon_parse.y" /* yacc.c:1646  */
    { mon_instructions_step(-1); }
#line 2636 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 49:
#line 286 "mon_parse.y" /* yacc.c:1646  */
    { mon_instructions_step((yyvsp[-1].i)); }
#line 2642 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 50:
#line 288 "mon_parse.y" /* yacc.c:1646  */
    { mon_instructions_next(-1); }
#line 2648 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 51:
#line 290 "mon_parse.y" /* yacc.c:1646  */
    { mon_instructions_next((yyvsp[-1].i)); }
#line 2654 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 52:
#line 292 "mon_parse.y" /* yacc.c:1646  */
    { mon_stack_up(-1); }
#line 2660 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 53:
#line 294 "mon_parse.y" /* yacc.c:1646  */
    { mon_stack_up((yyvsp[-1].i)); }
#line 2666 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 54:
#line 296 "mon_parse.y" /* yacc.c:1646  */
    { mon_stack_down(-1); }
#line 2672 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 55:
#line 298 "mon_parse.y" /* yacc.c:1646  */
    { mon_stack_down((yyvsp[-1].i)); }
#line 2678 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 56:
#line 300 "mon_parse.y" /* yacc.c:1646  */
    { mon_display_screen(-1); }
#line 2684 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 57:
#line 302 "mon_parse.y" /* yacc.c:1646  */
    { mon_display_screen((yyvsp[-1].a)); }
#line 2690 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 58:
#line 304 "mon_parse.y" /* yacc.c:1646  */
    {
                        mon_out("Warp mode is %s.\n",
                                vsync_get_warp_mode() ? "on" : "off");
                     }
#line 2699 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 59:
#line 309 "mon_parse.y" /* yacc.c:1646  */
    {
                        vsync_set_warp_mode(!vsync_get_warp_mode());
                     }
#line 2707 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 61:
#line 316 "mon_parse.y" /* yacc.c:1646  */
    { (monitor_cpu_for_memspace[default_memspace]->mon_register_print)(default_memspace); }
#line 2713 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 62:
#line 318 "mon_parse.y" /* yacc.c:1646  */
    { (monitor_cpu_for_memspace[(yyvsp[-1].i)]->mon_register_print)((yyvsp[-1].i)); }
#line 2719 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 64:
#line 323 "mon_parse.y" /* yacc.c:1646  */
    {
                        /* What about the memspace? */
                        mon_playback_commands((yyvsp[-1].str),true);
                    }
#line 2728 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 65:
#line 328 "mon_parse.y" /* yacc.c:1646  */
    {
                        /* What about the memspace? */
                        mon_playback_commands((yyvsp[-1].str),true);
                    }
#line 2737 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 66:
#line 333 "mon_parse.y" /* yacc.c:1646  */
    { mon_save_symbols((yyvsp[-3].i), (yyvsp[-1].str)); }
#line 2743 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 67:
#line 335 "mon_parse.y" /* yacc.c:1646  */
    { mon_save_symbols(e_default_space, (yyvsp[-1].str)); }
#line 2749 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 68:
#line 337 "mon_parse.y" /* yacc.c:1646  */
    { mon_add_name_to_symbol_table((yyvsp[-3].a), (yyvsp[-1].str)); }
#line 2755 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 69:
#line 339 "mon_parse.y" /* yacc.c:1646  */
    { mon_remove_name_from_symbol_table(e_default_space, (yyvsp[-1].str)); }
#line 2761 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 70:
#line 341 "mon_parse.y" /* yacc.c:1646  */
    { mon_remove_name_from_symbol_table((yyvsp[-3].i), (yyvsp[-1].str)); }
#line 2767 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 71:
#line 343 "mon_parse.y" /* yacc.c:1646  */
    { mon_print_symbol_table((yyvsp[-1].i)); }
#line 2773 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 72:
#line 345 "mon_parse.y" /* yacc.c:1646  */
    { mon_print_symbol_table(e_default_space); }
#line 2779 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 73:
#line 347 "mon_parse.y" /* yacc.c:1646  */
    { mon_clear_symbol_table((yyvsp[-1].i)); }
#line 2785 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 74:
#line 349 "mon_parse.y" /* yacc.c:1646  */
    { mon_clear_symbol_table(e_default_space); }
#line 2791 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 75:
#line 351 "mon_parse.y" /* yacc.c:1646  */
    {
                        mon_add_name_to_symbol_table((yyvsp[-1].a), mon_prepend_dot_to_name((yyvsp[-3].str)));
                    }
#line 2799 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 76:
#line 355 "mon_parse.y" /* yacc.c:1646  */
    {
                        mon_add_name_to_symbol_table((yyvsp[-2].a), mon_prepend_dot_to_name((yyvsp[-4].str)));
                    }
#line 2807 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 77:
#line 361 "mon_parse.y" /* yacc.c:1646  */
    { mon_start_assemble_mode((yyvsp[0].a), NULL); }
#line 2813 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 78:
#line 362 "mon_parse.y" /* yacc.c:1646  */
    { }
#line 2819 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 79:
#line 364 "mon_parse.y" /* yacc.c:1646  */
    { mon_start_assemble_mode((yyvsp[-1].a), NULL); }
#line 2825 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 80:
#line 366 "mon_parse.y" /* yacc.c:1646  */
    { mon_disassemble_lines((yyvsp[-1].range)[0], (yyvsp[-1].range)[1]); }
#line 2831 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 81:
#line 368 "mon_parse.y" /* yacc.c:1646  */
    { mon_disassemble_lines(BAD_ADDR, BAD_ADDR); }
#line 2837 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 82:
#line 372 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_move((yyvsp[-3].range)[0], (yyvsp[-3].range)[1], (yyvsp[-1].a)); }
#line 2843 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 83:
#line 374 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_compare((yyvsp[-3].range)[0], (yyvsp[-3].range)[1], (yyvsp[-1].a)); }
#line 2849 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 84:
#line 376 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_fill((yyvsp[-3].range)[0], (yyvsp[-3].range)[1],(unsigned char *)(yyvsp[-1].str)); }
#line 2855 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 85:
#line 378 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_hunt((yyvsp[-3].range)[0], (yyvsp[-3].range)[1],(unsigned char *)(yyvsp[-1].str)); }
#line 2861 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 86:
#line 380 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display((yyvsp[-3].rt), (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], DF_PETSCII); }
#line 2867 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 87:
#line 382 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display(default_radix, (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], DF_PETSCII); }
#line 2873 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 88:
#line 384 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display(default_radix, BAD_ADDR, BAD_ADDR, DF_PETSCII); }
#line 2879 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 89:
#line 386 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display_data((yyvsp[-1].range)[0], (yyvsp[-1].range)[1], 8, 8); }
#line 2885 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 90:
#line 388 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display_data(BAD_ADDR, BAD_ADDR, 8, 8); }
#line 2891 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 91:
#line 390 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display_data((yyvsp[-1].range)[0], (yyvsp[-1].range)[1], 24, 21); }
#line 2897 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 92:
#line 392 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display_data(BAD_ADDR, BAD_ADDR, 24, 21); }
#line 2903 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 93:
#line 394 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display(0, (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], DF_PETSCII); }
#line 2909 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 94:
#line 396 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display(0, BAD_ADDR, BAD_ADDR, DF_PETSCII); }
#line 2915 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 95:
#line 398 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display(0, (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], DF_SCREEN_CODE); }
#line 2921 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 96:
#line 400 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_display(0, BAD_ADDR, BAD_ADDR, DF_SCREEN_CODE); }
#line 2927 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 97:
#line 402 "mon_parse.y" /* yacc.c:1646  */
    { mon_memmap_zap(); }
#line 2933 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 98:
#line 404 "mon_parse.y" /* yacc.c:1646  */
    { mon_memmap_show(-1,BAD_ADDR,BAD_ADDR); }
#line 2939 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 99:
#line 406 "mon_parse.y" /* yacc.c:1646  */
    { mon_memmap_show((yyvsp[-1].i),BAD_ADDR,BAD_ADDR); }
#line 2945 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 100:
#line 408 "mon_parse.y" /* yacc.c:1646  */
    { mon_memmap_show((yyvsp[-2].i),(yyvsp[-1].range)[0],(yyvsp[-1].range)[1]); }
#line 2951 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 101:
#line 410 "mon_parse.y" /* yacc.c:1646  */
    { mon_memmap_save((yyvsp[-3].str),(yyvsp[-1].i)); }
#line 2957 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 102:
#line 414 "mon_parse.y" /* yacc.c:1646  */
    {
                      if ((yyvsp[-3].i)) {
                          temp = mon_breakpoint_add_checkpoint((yyvsp[-2].range)[0], (yyvsp[-2].range)[1], TRUE, (yyvsp[-3].i), FALSE, TRUE);
                      } else {
                          temp = mon_breakpoint_add_checkpoint((yyvsp[-2].range)[0], (yyvsp[-2].range)[1], TRUE, e_exec, FALSE, TRUE);
                      }
                      mon_breakpoint_set_checkpoint_condition(temp, (yyvsp[-1].cond_node));
                  }
#line 2970 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 103:
#line 423 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_print_checkpoints(); }
#line 2976 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 104:
#line 426 "mon_parse.y" /* yacc.c:1646  */
    {
                      mon_breakpoint_add_checkpoint((yyvsp[-1].range)[0], (yyvsp[-1].range)[1], TRUE, e_exec, TRUE, TRUE);
                  }
#line 2984 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 105:
#line 430 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_print_checkpoints(); }
#line 2990 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 106:
#line 433 "mon_parse.y" /* yacc.c:1646  */
    {
                      if ((yyvsp[-3].i)) {
                          temp = mon_breakpoint_add_checkpoint((yyvsp[-2].range)[0], (yyvsp[-2].range)[1], TRUE, (yyvsp[-3].i), FALSE, TRUE);
                      } else {
                          temp = mon_breakpoint_add_checkpoint((yyvsp[-2].range)[0], (yyvsp[-2].range)[1], TRUE, e_load | e_store, FALSE, TRUE);
                      }
                      mon_breakpoint_set_checkpoint_condition(temp, (yyvsp[-1].cond_node));
                  }
#line 3003 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 107:
#line 442 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_print_checkpoints(); }
#line 3009 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 108:
#line 445 "mon_parse.y" /* yacc.c:1646  */
    {
                      if ((yyvsp[-3].i)) {
                          temp = mon_breakpoint_add_checkpoint((yyvsp[-2].range)[0], (yyvsp[-2].range)[1], FALSE, (yyvsp[-3].i), FALSE, TRUE);
                      } else {
                          temp = mon_breakpoint_add_checkpoint((yyvsp[-2].range)[0], (yyvsp[-2].range)[1], FALSE, e_exec | e_load | e_store, FALSE, TRUE);
                      }
                      mon_breakpoint_set_checkpoint_condition(temp, (yyvsp[-1].cond_node));
                  }
#line 3022 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 109:
#line 454 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_print_checkpoints(); }
#line 3028 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 110:
#line 459 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_switch_checkpoint(e_ON, (yyvsp[-1].i)); }
#line 3034 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 111:
#line 461 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_switch_checkpoint(e_ON, -1); }
#line 3040 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 112:
#line 463 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_switch_checkpoint(e_OFF, (yyvsp[-1].i)); }
#line 3046 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 113:
#line 465 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_switch_checkpoint(e_OFF, -1); }
#line 3052 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 114:
#line 467 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_set_ignore_count((yyvsp[-1].i), -1); }
#line 3058 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 115:
#line 469 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_set_ignore_count((yyvsp[-3].i), (yyvsp[-1].i)); }
#line 3064 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 116:
#line 471 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_delete_checkpoint((yyvsp[-1].i)); }
#line 3070 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 117:
#line 473 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_delete_checkpoint(-1); }
#line 3076 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 118:
#line 475 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_set_checkpoint_condition((yyvsp[-3].i), (yyvsp[-1].cond_node)); }
#line 3082 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 119:
#line 477 "mon_parse.y" /* yacc.c:1646  */
    { mon_breakpoint_set_checkpoint_command((yyvsp[-3].i), (yyvsp[-1].str)); }
#line 3088 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 120:
#line 479 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_STRING; }
#line 3094 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 121:
#line 483 "mon_parse.y" /* yacc.c:1646  */
    { sidefx = (((yyvsp[-1].action) == e_TOGGLE) ? (sidefx ^ 1) : (yyvsp[-1].action)); }
#line 3100 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 122:
#line 485 "mon_parse.y" /* yacc.c:1646  */
    {
                         mon_out("I/O side effects are %s\n",
                                   sidefx ? "enabled" : "disabled");
                     }
#line 3109 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 123:
#line 490 "mon_parse.y" /* yacc.c:1646  */
    { 
                         break_on_dummy_access = (((yyvsp[-1].action) == e_TOGGLE) ? (break_on_dummy_access ^ 1) : (yyvsp[-1].action)); 
                         /* FIXME: some day we might want to toggle the break-on-dummy-access 
                                   per MEMSPACE, for now its a global option */                         
                         mon_breakpoint_set_dummy_state(e_default_space, break_on_dummy_access);
                     }
#line 3120 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 124:
#line 497 "mon_parse.y" /* yacc.c:1646  */
    {
                         mon_out("Checkpoints will %strigger on dummy accesses.\n",
                                   break_on_dummy_access ? "" : "not ");
                         /* FIXME: some day we might want to toggle the break-on-dummy-access 
                                   per MEMSPACE, for now its a global option */                         
                         mon_breakpoint_set_dummy_state(e_default_space, break_on_dummy_access);
                     }
#line 3132 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 125:
#line 505 "mon_parse.y" /* yacc.c:1646  */
    { 
                        int logenabled;
                        resources_get_int("MonitorLogEnabled", &logenabled);
                        logenabled = (((yyvsp[-1].action) == e_TOGGLE) ? (logenabled ^ 1) : (yyvsp[-1].action));
                        resources_set_int("MonitorLogEnabled", logenabled);
                     }
#line 3143 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 126:
#line 512 "mon_parse.y" /* yacc.c:1646  */
    {
                         int logenabled;
                         const char *logfilename;
                         resources_get_int("MonitorLogEnabled", &logenabled);
                         resources_get_string("MonitorLogFileName", &logfilename);
                         if (logenabled) {
                            mon_out("Logging to '%s' is enabled.\n", logfilename);
                         } else {
                            mon_out("Logging is disabled.\n");
                         }
                     }
#line 3159 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 127:
#line 524 "mon_parse.y" /* yacc.c:1646  */
    { 
                        resources_set_string("MonitorLogFileName", (yyvsp[-1].str));
                     }
#line 3167 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 128:
#line 528 "mon_parse.y" /* yacc.c:1646  */
    { default_radix = (yyvsp[-1].rt); }
#line 3173 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 129:
#line 530 "mon_parse.y" /* yacc.c:1646  */
    {
                         const char *p;

                         if (default_radix == e_hexadecimal)
                             p = "Hexadecimal";
                         else if (default_radix == e_decimal)
                             p = "Decimal";
                         else if (default_radix == e_octal)
                             p = "Octal";
                         else if (default_radix == e_binary)
                             p = "Binary";
                         else
                             p = "Unknown";

                         mon_out("Default radix is %s\n", p);
                     }
#line 3194 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 130:
#line 548 "mon_parse.y" /* yacc.c:1646  */
    { monitor_change_device(e_default_space); }
#line 3200 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 131:
#line 550 "mon_parse.y" /* yacc.c:1646  */
    { monitor_change_device((yyvsp[-1].i)); }
#line 3206 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 132:
#line 552 "mon_parse.y" /* yacc.c:1646  */
    { mon_export(); }
#line 3212 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 133:
#line 554 "mon_parse.y" /* yacc.c:1646  */
    { mon_quit(); YYACCEPT; }
#line 3218 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 134:
#line 556 "mon_parse.y" /* yacc.c:1646  */
    { mon_exit(); YYACCEPT; }
#line 3224 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 135:
#line 558 "mon_parse.y" /* yacc.c:1646  */
    { mon_maincpu_toggle_trace((yyvsp[-1].action)); }
#line 3230 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 136:
#line 562 "mon_parse.y" /* yacc.c:1646  */
    { mon_drive_execute_disk_cmd((yyvsp[-1].str)); }
#line 3236 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 137:
#line 564 "mon_parse.y" /* yacc.c:1646  */
    { mon_out("\t%d\n",(yyvsp[-1].i)); }
#line 3242 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 138:
#line 566 "mon_parse.y" /* yacc.c:1646  */
    { mon_command_print_help(NULL); }
#line 3248 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 139:
#line 568 "mon_parse.y" /* yacc.c:1646  */
    { mon_command_print_help((yyvsp[-1].str)); }
#line 3254 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 140:
#line 570 "mon_parse.y" /* yacc.c:1646  */
    { mon_print_convert((yyvsp[-1].i)); }
#line 3260 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 141:
#line 572 "mon_parse.y" /* yacc.c:1646  */
    { mon_change_dir((yyvsp[-1].str)); }
#line 3266 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 142:
#line 574 "mon_parse.y" /* yacc.c:1646  */
    { mon_keyboard_feed((yyvsp[-1].str)); }
#line 3272 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 143:
#line 576 "mon_parse.y" /* yacc.c:1646  */
    { mon_backtrace(); }
#line 3278 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 144:
#line 578 "mon_parse.y" /* yacc.c:1646  */
    { mon_show_dir((yyvsp[-1].str)); }
#line 3284 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 145:
#line 580 "mon_parse.y" /* yacc.c:1646  */
    { mon_show_pwd(); }
#line 3290 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 146:
#line 582 "mon_parse.y" /* yacc.c:1646  */
    { mon_make_dir((yyvsp[-1].str)); }
#line 3296 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 147:
#line 584 "mon_parse.y" /* yacc.c:1646  */
    { mon_remove_dir((yyvsp[-1].str)); }
#line 3302 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 148:
#line 586 "mon_parse.y" /* yacc.c:1646  */
    { mon_screenshot_save((yyvsp[-1].str),-1); }
#line 3308 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 149:
#line 588 "mon_parse.y" /* yacc.c:1646  */
    { mon_screenshot_save((yyvsp[-3].str),(yyvsp[-1].i)); }
#line 3314 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 150:
#line 590 "mon_parse.y" /* yacc.c:1646  */
    { mon_resource_get((yyvsp[-1].str)); }
#line 3320 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 151:
#line 592 "mon_parse.y" /* yacc.c:1646  */
    { mon_resource_set((yyvsp[-2].str),(yyvsp[-1].str)); }
#line 3326 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 152:
#line 594 "mon_parse.y" /* yacc.c:1646  */
    { resources_load((yyvsp[-1].str)); }
#line 3332 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 153:
#line 596 "mon_parse.y" /* yacc.c:1646  */
    { resources_save((yyvsp[-1].str)); }
#line 3338 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 154:
#line 598 "mon_parse.y" /* yacc.c:1646  */
    { mon_reset_machine(-1); }
#line 3344 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 155:
#line 600 "mon_parse.y" /* yacc.c:1646  */
    { mon_reset_machine((yyvsp[-1].i)); }
#line 3350 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 156:
#line 602 "mon_parse.y" /* yacc.c:1646  */
    { mon_tape_ctrl(TAPEPORT_PORT_1, (yyvsp[-1].i)); }
#line 3356 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 157:
#line 604 "mon_parse.y" /* yacc.c:1646  */
    { mon_cart_freeze(); }
#line 3362 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 158:
#line 606 "mon_parse.y" /* yacc.c:1646  */
    { mon_userport_set_output((yyvsp[-1].i)); }
#line 3368 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 159:
#line 608 "mon_parse.y" /* yacc.c:1646  */
    { mon_joyport_set_output((yyvsp[-2].i), (yyvsp[-1].i)); }
#line 3374 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 160:
#line 610 "mon_parse.y" /* yacc.c:1646  */
    { }
#line 3380 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 161:
#line 612 "mon_parse.y" /* yacc.c:1646  */
    { mon_stopwatch_reset(); }
#line 3386 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 162:
#line 614 "mon_parse.y" /* yacc.c:1646  */
    { mon_stopwatch_show("Stopwatch: ", "\n"); }
#line 3392 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 163:
#line 618 "mon_parse.y" /* yacc.c:1646  */
    { mon_file_load((yyvsp[-3].str), (yyvsp[-2].i), (yyvsp[-1].a), FALSE); }
#line 3398 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 164:
#line 620 "mon_parse.y" /* yacc.c:1646  */
    { mon_file_load((yyvsp[-3].str), (yyvsp[-2].i), (yyvsp[-1].a), TRUE); }
#line 3404 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 165:
#line 622 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_ADDRESS; }
#line 3410 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 166:
#line 624 "mon_parse.y" /* yacc.c:1646  */
    { mon_file_save((yyvsp[-3].str), (yyvsp[-2].i), (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], FALSE); }
#line 3416 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 167:
#line 626 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_DEVICE_NUM; }
#line 3422 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 168:
#line 628 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_ADDRESS; }
#line 3428 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 169:
#line 630 "mon_parse.y" /* yacc.c:1646  */
    { mon_file_save((yyvsp[-3].str), (yyvsp[-2].i), (yyvsp[-1].range)[0], (yyvsp[-1].range)[1], TRUE); }
#line 3434 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 170:
#line 632 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_ADDRESS; }
#line 3440 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 171:
#line 634 "mon_parse.y" /* yacc.c:1646  */
    { mon_file_verify((yyvsp[-3].str),(yyvsp[-2].i),(yyvsp[-1].a),FALSE); }
#line 3446 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 172:
#line 636 "mon_parse.y" /* yacc.c:1646  */
    { mon_file_verify((yyvsp[-3].str),(yyvsp[-2].i),(yyvsp[-1].a),TRUE); }
#line 3452 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 173:
#line 638 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_ADDRESS; }
#line 3458 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 174:
#line 640 "mon_parse.y" /* yacc.c:1646  */
    { mon_drive_block_cmd(0,(yyvsp[-3].i),(yyvsp[-2].i),(yyvsp[-1].a)); }
#line 3464 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 175:
#line 642 "mon_parse.y" /* yacc.c:1646  */
    { mon_drive_block_cmd(1,(yyvsp[-3].i),(yyvsp[-2].i),(yyvsp[-1].a)); }
#line 3470 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 176:
#line 644 "mon_parse.y" /* yacc.c:1646  */
    { mon_drive_list(-1); }
#line 3476 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 177:
#line 646 "mon_parse.y" /* yacc.c:1646  */
    { mon_drive_list((yyvsp[-1].i)); }
#line 3482 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 178:
#line 648 "mon_parse.y" /* yacc.c:1646  */
    { mon_attach((yyvsp[-2].str),(yyvsp[-1].i)); }
#line 3488 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 179:
#line 650 "mon_parse.y" /* yacc.c:1646  */
    { mon_detach((yyvsp[-1].i)); }
#line 3494 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 180:
#line 652 "mon_parse.y" /* yacc.c:1646  */
    { mon_autostart((yyvsp[-1].str),0,1); }
#line 3500 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 181:
#line 654 "mon_parse.y" /* yacc.c:1646  */
    { mon_autostart((yyvsp[-3].str),(yyvsp[-1].i),1); }
#line 3506 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 182:
#line 656 "mon_parse.y" /* yacc.c:1646  */
    { mon_autostart((yyvsp[-1].str),0,0); }
#line 3512 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 183:
#line 658 "mon_parse.y" /* yacc.c:1646  */
    { mon_autostart((yyvsp[-3].str),(yyvsp[-1].i),0); }
#line 3518 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 184:
#line 662 "mon_parse.y" /* yacc.c:1646  */
    { mon_record_commands((yyvsp[-1].str)); }
#line 3524 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 185:
#line 664 "mon_parse.y" /* yacc.c:1646  */
    { mon_end_recording(); }
#line 3530 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 186:
#line 666 "mon_parse.y" /* yacc.c:1646  */
    { mon_playback_commands((yyvsp[-1].str),true); }
#line 3536 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 187:
#line 670 "mon_parse.y" /* yacc.c:1646  */
    { mon_memory_fill((yyvsp[-2].a), BAD_ADDR, (unsigned char *)(yyvsp[-1].str)); }
#line 3542 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 188:
#line 672 "mon_parse.y" /* yacc.c:1646  */
    { printf("Not yet.\n"); }
#line 3548 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 189:
#line 676 "mon_parse.y" /* yacc.c:1646  */
    { yydebug = 1; }
#line 3554 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 190:
#line 679 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 3560 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 191:
#line 682 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 3566 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 192:
#line 683 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 3572 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 193:
#line 686 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 3578 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 195:
#line 690 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_FILENAME; }
#line 3584 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 197:
#line 694 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_DEVICE_NUM; }
#line 3590 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 198:
#line 697 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i) | (yyvsp[0].i); }
#line 3596 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 199:
#line 698 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3602 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 200:
#line 701 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3608 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 201:
#line 702 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3614 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 202:
#line 705 "mon_parse.y" /* yacc.c:1646  */
    {
                                    if (!mon_register_valid(default_memspace, (yyvsp[0].reg))) {
                                        return ERR_INVALID_REGISTER;
                                    }
                                    (yyval.i) = new_reg(default_memspace, (yyvsp[0].reg));
                                }
#line 3625 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 203:
#line 711 "mon_parse.y" /* yacc.c:1646  */
    {
                                    if (!mon_register_valid((yyvsp[-1].i), (yyvsp[0].reg))) {
                                        return ERR_INVALID_REGISTER;
                                    }
                                    (yyval.i) = new_reg((yyvsp[-1].i), (yyvsp[0].reg));
                                }
#line 3636 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 206:
#line 724 "mon_parse.y" /* yacc.c:1646  */
    { (monitor_cpu_for_memspace[reg_memspace((yyvsp[-2].i))]->mon_register_set_val)(reg_memspace((yyvsp[-2].i)), reg_regid((yyvsp[-2].i)), (uint16_t) (yyvsp[0].i)); }
#line 3642 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 207:
#line 727 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3648 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 208:
#line 728 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_EXPECT_CHECKNUM; }
#line 3654 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 210:
#line 732 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.range)[0] = (yyvsp[0].a); (yyval.range)[1] = BAD_ADDR; }
#line 3660 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 211:
#line 735 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.range)[0] = (yyvsp[-2].a); (yyval.range)[1] = (yyvsp[0].a); }
#line 3666 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 212:
#line 737 "mon_parse.y" /* yacc.c:1646  */
    { if (resolve_range(e_default_space, (yyval.range), (yyvsp[0].str))) return ERR_ADDR_TOO_BIG; }
#line 3672 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 213:
#line 739 "mon_parse.y" /* yacc.c:1646  */
    { if (resolve_range((yyvsp[-2].i), (yyval.range), (yyvsp[0].str))) return ERR_ADDR_TOO_BIG; }
#line 3678 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 214:
#line 742 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 3684 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 215:
#line 743 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.a) = BAD_ADDR; }
#line 3690 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 216:
#line 747 "mon_parse.y" /* yacc.c:1646  */
    {
             (yyval.a) = new_addr(e_default_space,(yyvsp[0].i));
             if (opt_asm) new_cmd = asm_mode = 1;
         }
#line 3699 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 217:
#line 752 "mon_parse.y" /* yacc.c:1646  */
    {
             (yyval.a) = new_addr((yyvsp[-2].i), (yyvsp[0].i));
             if (opt_asm) new_cmd = asm_mode = 1;
         }
#line 3708 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 218:
#line 757 "mon_parse.y" /* yacc.c:1646  */
    {
             temp = mon_symbol_table_lookup_addr(e_default_space, (yyvsp[0].str));
             if (temp >= 0)
                 (yyval.a) = new_addr(e_default_space, temp);
             else
                 return ERR_UNDEFINED_LABEL;
         }
#line 3720 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 221:
#line 770 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = e_comp_space; }
#line 3726 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 222:
#line 771 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = e_disk8_space; }
#line 3732 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 223:
#line 772 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = e_disk9_space; }
#line 3738 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 224:
#line 773 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = e_disk10_space; }
#line 3744 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 225:
#line 774 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = e_disk11_space; }
#line 3750 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 226:
#line 777 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); if (!CHECK_ADDR((yyvsp[0].i))) return ERR_ADDR_TOO_BIG; }
#line 3756 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 227:
#line 779 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3762 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 228:
#line 781 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) + (yyvsp[0].i); }
#line 3768 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 229:
#line 782 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) - (yyvsp[0].i); }
#line 3774 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 230:
#line 783 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) * (yyvsp[0].i); }
#line 3780 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 231:
#line 784 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i)) ? ((yyvsp[-2].i) / (yyvsp[0].i)) : 1; }
#line 3786 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 232:
#line 785 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 3792 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 233:
#line 786 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_MISSING_CLOSE_PAREN; }
#line 3798 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 234:
#line 787 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3804 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 235:
#line 790 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.cond_node) = (yyvsp[0].cond_node); }
#line 3810 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 236:
#line 791 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.cond_node) = 0; }
#line 3816 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 237:
#line 794 "mon_parse.y" /* yacc.c:1646  */
    {
               (yyval.cond_node) = new_cond; (yyval.cond_node)->is_parenthized = FALSE;
               (yyval.cond_node)->child1 = (yyvsp[-2].cond_node); (yyval.cond_node)->child2 = (yyvsp[0].cond_node); (yyval.cond_node)->operation = (yyvsp[-1].cond_op);
           }
#line 3825 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 238:
#line 799 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_INCOMPLETE_COND_OP; }
#line 3831 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 239:
#line 801 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.cond_node) = (yyvsp[-1].cond_node); (yyval.cond_node)->is_parenthized = TRUE; }
#line 3837 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 240:
#line 803 "mon_parse.y" /* yacc.c:1646  */
    { return ERR_MISSING_CLOSE_PAREN; }
#line 3843 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 241:
#line 805 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.cond_node) = (yyvsp[0].cond_node); }
#line 3849 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 242:
#line 808 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.cond_node) = new_cond;
                            (yyval.cond_node)->operation = e_INV;
                            (yyval.cond_node)->is_parenthized = FALSE;
                            (yyval.cond_node)->reg_num = (yyvsp[0].i); (yyval.cond_node)->is_reg = TRUE; (yyval.cond_node)->banknum=-1;
                            (yyval.cond_node)->child1 = NULL; (yyval.cond_node)->child2 = NULL;
                          }
#line 3860 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 243:
#line 814 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.cond_node) = new_cond;
                            (yyval.cond_node)->operation = e_INV;
                            (yyval.cond_node)->is_parenthized = FALSE;
                            (yyval.cond_node)->value = (yyvsp[0].i); (yyval.cond_node)->is_reg = FALSE; (yyval.cond_node)->banknum=-1;
                            (yyval.cond_node)->child1 = NULL; (yyval.cond_node)->child2 = NULL;
                          }
#line 3871 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 244:
#line 820 "mon_parse.y" /* yacc.c:1646  */
    {(yyval.cond_node)=new_cond;
                            (yyval.cond_node)->operation=e_INV;
                            (yyval.cond_node)->is_parenthized = FALSE;
                            (yyval.cond_node)->banknum = mon_banknum_from_bank(e_default_space, (yyvsp[-2].str));
                            if ((yyval.cond_node)->banknum < 0) {
                                return ERR_ILLEGAL_INPUT;
                            }
                            (yyval.cond_node)->value = (yyvsp[0].a); (yyval.cond_node)->is_reg = FALSE;
                            (yyval.cond_node)->child1 = NULL; (yyval.cond_node)->child2 = NULL;  
                        }
#line 3886 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 247:
#line 836 "mon_parse.y" /* yacc.c:1646  */
    { mon_add_number_to_buffer((yyvsp[0].i)); }
#line 3892 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 248:
#line 837 "mon_parse.y" /* yacc.c:1646  */
    { mon_add_string_to_buffer((yyvsp[0].str)); }
#line 3898 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 251:
#line 844 "mon_parse.y" /* yacc.c:1646  */
    { mon_add_number_to_buffer((yyvsp[0].i)); }
#line 3904 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 252:
#line 845 "mon_parse.y" /* yacc.c:1646  */
    { mon_add_number_masked_to_buffer((yyvsp[0].i), 0x00); }
#line 3910 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 253:
#line 846 "mon_parse.y" /* yacc.c:1646  */
    { mon_add_string_to_buffer((yyvsp[0].str)); }
#line 3916 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 254:
#line 849 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3922 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 255:
#line 850 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (monitor_cpu_for_memspace[reg_memspace((yyvsp[0].i))]->mon_register_get_val)(reg_memspace((yyvsp[0].i)), reg_regid((yyvsp[0].i))); }
#line 3928 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 256:
#line 853 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3934 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 257:
#line 854 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (int)strtol((yyvsp[0].str), NULL, 10); }
#line 3940 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 258:
#line 855 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (int)strtol((yyvsp[0].str), NULL, 10); }
#line 3946 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 259:
#line 856 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (int)strtol((yyvsp[0].str), NULL, 10); }
#line 3952 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 260:
#line 859 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = resolve_datatype(B_NUMBER,(yyvsp[0].str)); }
#line 3958 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 261:
#line 860 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = resolve_datatype(O_NUMBER,(yyvsp[0].str)); }
#line 3964 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 262:
#line 861 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = resolve_datatype(D_NUMBER,(yyvsp[0].str)); }
#line 3970 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 263:
#line 864 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3976 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 264:
#line 865 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3982 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 265:
#line 866 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3988 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 266:
#line 867 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 3994 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 267:
#line 868 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4000 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 271:
#line 876 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0;
                                                if ((yyvsp[-1].str)) {
                                                    (monitor_cpu_for_memspace[default_memspace]->mon_assemble_instr)((yyvsp[-1].str), (yyvsp[0].mode));
                                                } else {
                                                    new_cmd = 1;
                                                    asm_mode = 0;
                                                }
                                                opt_asm = 0;
                                              }
#line 4014 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 273:
#line 887 "mon_parse.y" /* yacc.c:1646  */
    { asm_mode = 0; }
#line 4020 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 274:
#line 890 "mon_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[0].i) > 0xff) {
                          (yyval.mode).addr_mode = ASM_ADDR_MODE_IMMEDIATE_16;
                          (yyval.mode).param = (yyvsp[0].i);
                        } else {
                          (yyval.mode).addr_mode = ASM_ADDR_MODE_IMMEDIATE;
                          (yyval.mode).param = (yyvsp[0].i);
                        } }
#line 4032 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 275:
#line 897 "mon_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[0].i) >= 0x10000) {
               (yyval.mode).addr_mode = ASM_ADDR_MODE_ABSOLUTE_LONG;
               (yyval.mode).param = (yyvsp[0].i);
             } else if ((yyvsp[0].i) < 0x100) {
               (yyval.mode).addr_mode = ASM_ADDR_MODE_ZERO_PAGE;
               (yyval.mode).param = (yyvsp[0].i);
             } else {
               (yyval.mode).addr_mode = ASM_ADDR_MODE_ABSOLUTE;
               (yyval.mode).param = (yyvsp[0].i);
             }
           }
#line 4048 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 276:
#line 908 "mon_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].i) >= 0x10000) {
                            (yyval.mode).addr_mode = ASM_ADDR_MODE_ABSOLUTE_LONG_X;
                            (yyval.mode).param = (yyvsp[-2].i);
                          } else if ((yyvsp[-2].i) < 0x100) { 
                            (yyval.mode).addr_mode = ASM_ADDR_MODE_ZERO_PAGE_X;
                            (yyval.mode).param = (yyvsp[-2].i);
                          } else {
                            (yyval.mode).addr_mode = ASM_ADDR_MODE_ABSOLUTE_X;
                            (yyval.mode).param = (yyvsp[-2].i);
                          }
                        }
#line 4064 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 277:
#line 919 "mon_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].i) < 0x100) {
                            (yyval.mode).addr_mode = ASM_ADDR_MODE_ZERO_PAGE_Y;
                            (yyval.mode).param = (yyvsp[-2].i);
                          } else {
                            (yyval.mode).addr_mode = ASM_ADDR_MODE_ABSOLUTE_Y;
                            (yyval.mode).param = (yyvsp[-2].i);
                          }
                        }
#line 4077 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 278:
#line 927 "mon_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].i) < 0x100) {
                            (yyval.mode).addr_mode = ASM_ADDR_MODE_STACK_RELATIVE;
                            (yyval.mode).param = (yyvsp[-2].i);
                          } else { /* 6809 */
                            (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
                            if ((yyvsp[-2].i) >= -16 && (yyvsp[-2].i) < 16) {
                                (yyval.mode).addr_submode = (yyvsp[0].i) | ((yyvsp[-2].i) & 0x1F);
                            } else if ((yyvsp[-2].i) >= -128 && (yyvsp[-2].i) < 128) {
                                (yyval.mode).addr_submode = 0x80 | (yyvsp[0].i) | ASM_ADDR_MODE_INDEXED_OFF8;
                                (yyval.mode).param = (yyvsp[-2].i);
                            } else if ((yyvsp[-2].i) >= -32768 && (yyvsp[-2].i) < 32768) {
                                (yyval.mode).addr_submode = 0x80 | (yyvsp[0].i) | ASM_ADDR_MODE_INDEXED_OFF16;
                                (yyval.mode).param = (yyvsp[-2].i);
                            } else {
                                (yyval.mode).addr_mode = ASM_ADDR_MODE_ILLEGAL;
                                mon_out("offset too large even for 16 bits (signed)\n");
                            }
                          }
                        }
#line 4101 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 279:
#line 946 "mon_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].i) < 0x100) {
                            (yyval.mode).addr_mode = ASM_ADDR_MODE_DOUBLE;
                            (yyval.mode).param = (yyvsp[0].i);
                            (yyval.mode).addr_submode = (yyvsp[-2].i);
                          }
                        }
#line 4112 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 280:
#line 952 "mon_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].i) < 0x100) {
                               (yyval.mode).addr_mode = ASM_ADDR_MODE_INDIRECT;
                               (yyval.mode).param = (yyvsp[-1].i);
                             } else {
                               (yyval.mode).addr_mode = ASM_ADDR_MODE_ABS_INDIRECT;
                               (yyval.mode).param = (yyvsp[-1].i);
                             }
                           }
#line 4125 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 281:
#line 960 "mon_parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-3].i) < 0x100) {
                                           (yyval.mode).addr_mode = ASM_ADDR_MODE_INDIRECT_X;
                                           (yyval.mode).param = (yyvsp[-3].i);
                                         } else {
                                           (yyval.mode).addr_mode = ASM_ADDR_MODE_ABS_INDIRECT_X;
                                           (yyval.mode).param = (yyvsp[-3].i);
                                         }
                                       }
#line 4138 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 282:
#line 969 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_STACK_RELATIVE_Y; (yyval.mode).param = (yyvsp[-5].i); }
#line 4144 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 283:
#line 971 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_INDIRECT_Y; (yyval.mode).param = (yyvsp[-3].i); }
#line 4150 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 284:
#line 972 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IND_BC; }
#line 4156 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 285:
#line 973 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IND_DE; }
#line 4162 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 286:
#line 974 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IND_HL; }
#line 4168 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 287:
#line 975 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IND_IX; }
#line 4174 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 288:
#line 976 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IND_IY; }
#line 4180 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 289:
#line 977 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IND_SP; }
#line 4186 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 290:
#line 979 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_ABSOLUTE_A; (yyval.mode).param = (yyvsp[-3].i); }
#line 4192 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 291:
#line 981 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_ABSOLUTE_HL; (yyval.mode).param = (yyvsp[-3].i); }
#line 4198 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 292:
#line 983 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_ABSOLUTE_IX; (yyval.mode).param = (yyvsp[-3].i); }
#line 4204 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 293:
#line 985 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_ABSOLUTE_IY; (yyval.mode).param = (yyvsp[-3].i); }
#line 4210 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 294:
#line 986 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_IMPLIED; }
#line 4216 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 295:
#line 987 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_ACCUMULATOR; }
#line 4222 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 296:
#line 988 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_B; }
#line 4228 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 297:
#line 989 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_C; }
#line 4234 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 298:
#line 990 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_D; }
#line 4240 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 299:
#line 991 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_E; }
#line 4246 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 300:
#line 992 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_H; }
#line 4252 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 301:
#line 993 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IXH; }
#line 4258 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 302:
#line 994 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IYH; }
#line 4264 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 303:
#line 995 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_L; }
#line 4270 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 304:
#line 996 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IXL; }
#line 4276 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 305:
#line 997 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IYL; }
#line 4282 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 306:
#line 998 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_AF; }
#line 4288 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 307:
#line 999 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_BC; }
#line 4294 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1000 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_DE; }
#line 4300 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1001 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_HL; }
#line 4306 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1002 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IX; }
#line 4312 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1003 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_IY; }
#line 4318 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1004 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_REG_SP; }
#line 4324 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1006 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.mode).addr_mode = ASM_ADDR_MODE_DIRECT; (yyval.mode).param = (yyvsp[0].i); }
#line 4330 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1007 "mon_parse.y" /* yacc.c:1646  */
    {    /* Clash with addr,x addr,y addr,s modes! */
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        if ((yyvsp[-2].i) >= -16 && (yyvsp[-2].i) < 16) {
            (yyval.mode).addr_submode = (3 << 5) | ((yyvsp[-2].i) & 0x1F);
        } else if ((yyvsp[-2].i) >= -128 && (yyvsp[-2].i) < 128) {
            (yyval.mode).addr_submode = 0x80 | (3 << 5) | ASM_ADDR_MODE_INDEXED_OFF8;
            (yyval.mode).param = (yyvsp[-2].i);
        } else if ((yyvsp[-2].i) >= -32768 && (yyvsp[-2].i) < 32768) {
            (yyval.mode).addr_submode = 0x80 | (3 << 5) | ASM_ADDR_MODE_INDEXED_OFF16;
            (yyval.mode).param = (yyvsp[-2].i);
        } else {
            (yyval.mode).addr_mode = ASM_ADDR_MODE_ILLEGAL;
            mon_out("offset too large even for 16 bits (signed)\n");
        }
    }
#line 4350 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1022 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-1].i) | ASM_ADDR_MODE_INDEXED_INC1;
        }
#line 4359 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1026 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-2].i) | ASM_ADDR_MODE_INDEXED_INC2;
        }
#line 4368 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1030 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[0].i) | ASM_ADDR_MODE_INDEXED_DEC1;
        }
#line 4377 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1034 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[0].i) | ASM_ADDR_MODE_INDEXED_DEC2;
        }
#line 4386 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1038 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[0].i) | ASM_ADDR_MODE_INDEXED_OFF0;
        }
#line 4395 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1042 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-1].i) | ASM_ADDR_MODE_INDEXED_OFFB;
        }
#line 4404 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1046 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-1].i) | ASM_ADDR_MODE_INDEXED_OFFA;
        }
#line 4413 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1050 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-1].i) | ASM_ADDR_MODE_INDEXED_OFFD;
        }
#line 4422 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1054 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).param = (yyvsp[-2].i);
        if ((yyvsp[-2].i) >= -128 && (yyvsp[-2].i) < 128) {
            (yyval.mode).addr_submode = ASM_ADDR_MODE_INDEXED_OFFPC8;
        } else if ((yyvsp[-2].i) >= -32768 && (yyvsp[-2].i) < 32768) {
            (yyval.mode).addr_submode = ASM_ADDR_MODE_INDEXED_OFFPC16;
        } else {
            (yyval.mode).addr_mode = ASM_ADDR_MODE_ILLEGAL;
            mon_out("offset too large even for 16 bits (signed)\n");
        }
    }
#line 4439 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1066 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        if ((yyvsp[-3].i) >= -16 && (yyvsp[-3].i) < 16) {
            (yyval.mode).addr_submode = (yyvsp[-3].i) & 0x1F;
        } else if ((yyvsp[-4].i) >= -128 && (yyvsp[-4].i) < 128) {
            (yyval.mode).addr_submode = ASM_ADDR_MODE_INDEXED_OFF8;
            (yyval.mode).param = (yyvsp[-3].i);
        } else if ((yyvsp[-3].i) >= -32768 && (yyvsp[-3].i) < 32768) {
            (yyval.mode).addr_submode = ASM_ADDR_MODE_INDEXED_OFF16;
            (yyval.mode).param = (yyvsp[-3].i);
        } else {
            (yyval.mode).addr_mode = ASM_ADDR_MODE_ILLEGAL;
            mon_out("offset too large even for 16 bits (signed)\n");
        }
    }
#line 4459 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1081 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-2].i) | ASM_ADDR_MODE_INDEXED_INC1;
        }
#line 4468 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1085 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-3].i) | ASM_ADDR_MODE_INDEXED_INC2;
        }
#line 4477 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1089 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-1].i) | ASM_ADDR_MODE_INDEXED_DEC1;
        }
#line 4486 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1093 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-1].i) | ASM_ADDR_MODE_INDEXED_DEC2;
        }
#line 4495 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1097 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-1].i) | ASM_ADDR_MODE_INDEXED_OFF0;
        }
#line 4504 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1101 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-2].i) | ASM_ADDR_MODE_INDEXED_OFFB;
        }
#line 4513 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1105 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-2].i) | ASM_ADDR_MODE_INDEXED_OFFA;
        }
#line 4522 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1109 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | (yyvsp[-2].i) | ASM_ADDR_MODE_INDEXED_OFFD;
        }
#line 4531 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1113 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).param = (yyvsp[-3].i);
        if ((yyvsp[-3].i) >= -128 && (yyvsp[-3].i) < 128) {
            (yyval.mode).addr_submode = ASM_ADDR_MODE_INDEXED_OFFPC8_IND;
        } else if ((yyvsp[-3].i) >= -32768 && (yyvsp[-3].i) < 32768) {
            (yyval.mode).addr_submode = ASM_ADDR_MODE_INDEXED_OFFPC16_IND;
        } else {
            (yyval.mode).addr_mode = ASM_ADDR_MODE_ILLEGAL;
            mon_out("offset too large even for 16 bits (signed)\n");
        }
    }
#line 4548 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1125 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDEXED;
        (yyval.mode).addr_submode = 0x80 | ASM_ADDR_MODE_EXTENDED_INDIRECT;
        (yyval.mode).param = (yyvsp[-1].i);
        }
#line 4558 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1130 "mon_parse.y" /* yacc.c:1646  */
    {
        (yyval.mode).addr_mode = ASM_ADDR_MODE_INDIRECT_LONG_Y;
        (yyval.mode).param = (yyvsp[-3].i);
        }
#line 4567 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1138 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (0 << 5); printf("reg_x\n"); }
#line 4573 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1139 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (1 << 5); printf("reg_y\n"); }
#line 4579 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1140 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4585 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1141 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (3 << 5); printf("reg_s\n"); }
#line 4591 "mon_parse.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1145 "mon_parse.y" /* yacc.c:1646  */
    { (yyval.i) = (2 << 5); printf("reg_u\n"); }
#line 4597 "mon_parse.c" /* yacc.c:1646  */
    break;


#line 4601 "mon_parse.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1149 "mon_parse.y" /* yacc.c:1906  */


int parse_and_execute_line(char *input)
{
   char *temp_buf;
   int i, rc;

   if (default_memspace == e_comp_space) {
       /*
        * If the command is to be executed when the default address space is the main cpu,
        * Ensure drive CPU emulation is up to date with main cpu CLOCK.
        */
       drive_cpu_execute_all(maincpu_clk);
   }

   temp_buf = lib_malloc(strlen(input) + 3);
   strcpy(temp_buf,input);
   i = (int)strlen(input);
   temp_buf[i++] = '\n';
   temp_buf[i++] = '\0';
   temp_buf[i++] = '\0';

   make_buffer(temp_buf);
   mon_clear_buffer();
   if ( (rc =yyparse()) != 0) {
       mon_out("ERROR -- ");
       switch(rc) {
         case ERR_BAD_CMD:
           mon_out("Bad command:\n");
           break;
         case ERR_RANGE_BAD_START:
           mon_out("Bad first address in range:\n");
           break;
         case ERR_RANGE_BAD_END:
           mon_out("Bad second address in range:\n");
           break;
         case ERR_EXPECT_CHECKNUM:
           mon_out("Checkpoint number expected:\n");
           break;
         case ERR_EXPECT_END_CMD:
           mon_out("Unexpected token:\n");
           break;
         case ERR_MISSING_CLOSE_PAREN:
           mon_out("')' expected:\n");
           break;
         case ERR_INCOMPLETE_COND_OP:
           mon_out("Conditional operation missing an operand:\n");
           break;
         case ERR_EXPECT_FILENAME:
           mon_out("Expecting a filename:\n");
           break;
         case ERR_ADDR_TOO_BIG:
           mon_out("Address too large:\n");
           break;
         case ERR_IMM_TOO_BIG:
           mon_out("Immediate argument too large:\n");
           break;
         case ERR_EXPECT_STRING:
           mon_out("Expecting a string.\n");
           break;
         case ERR_UNDEFINED_LABEL:
           mon_out("Found an undefined label.\n");
           break;
         case ERR_EXPECT_DEVICE_NUM:
           mon_out("Expecting a device number.\n");
           break;
         case ERR_EXPECT_ADDRESS:
           mon_out("Expecting an address.\n");
           break;
         case ERR_INVALID_REGISTER:
           mon_out("Invalid register.\n");
           break;
         case ERR_ILLEGAL_INPUT:
         default:
           mon_out("Wrong syntax:\n");
       }
       mon_out("  %s\n", input);
       for (i = 0; i < last_len; i++)
           mon_out(" ");
       mon_out("  ^\n");
       asm_mode = 0;
       new_cmd = 1;
   }
   lib_free(temp_buf);
   free_buffer();

   return rc;
}

static int yyerror(char *s)
{
#if 0
   fprintf(stderr, "ERR:%s\n", s);
#endif
   return 0;
}

static int resolve_datatype(unsigned guess_type, const char *num)
{
   /* FIXME: Handle cases when default type is non-numerical */
   if (default_radix == e_hexadecimal) {
       return (int)strtol(num, NULL, 16);
   }

   if ((guess_type == D_NUMBER) || (default_radix == e_decimal)) {
       return (int)strtol(num, NULL, 10);
   }

   if ((guess_type == O_NUMBER) || (default_radix == e_octal)) {
       return (int)strtol(num, NULL, 8);
   }

   return (int)strtol(num, NULL, 2);
}

/*
 * Resolve a character sequence containing 8 hex digits like "08001000".
 * This could be a lazy version of "0800 1000". If the default radix is not
 * hexadecimal, we handle it like a ordinary number, in the latter case there
 * is only one number in the range.
 */
static int resolve_range(enum t_memspace memspace, MON_ADDR range[2],
                         const char *num)
{
    char start[5];
    char end[5];
    long sa;

    range[1] = BAD_ADDR;

    switch (default_radix)
    {
    case e_hexadecimal:
        /* checked twice, but as the code must have exactly 8 digits: */
        if (strlen(num) == 8) {
            memcpy(start, num, 4);
            start[4] = '\0';
            memcpy(end, num + 4, 4);
            end[4] = '\0';
            sa = strtol(start, NULL, 16);
            range[1] = (int)new_addr(memspace, strtol(end, NULL, 16));
        }
        else
            sa = strtol(num, NULL, 16);
        break;

    case e_decimal:
       sa = strtol(num, NULL, 10);
       break;

    case e_octal:
       sa = strtol(num, NULL, 8);
       break;

    default:
       sa = strtol(num, NULL, 2);
    }

    if (!CHECK_ADDR(sa))
        return ERR_ADDR_TOO_BIG;

    range[0] = (int)new_addr(memspace, sa);
    return 0;
}
